"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Banner = Banner;

var _react = _interopRequireWildcard(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _Heading = require("../Heading");

var _HeadingGroup = require("../HeadingGroup");

var _Bookend = require("../Bookend");

var _Icon = require("../Icon");

var _View = require("../View");

var _TextContainer = require("../TextContainer");

var _Button = require("../Button");

var _Banner = _interopRequireDefault(require("./Banner.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function Banner(_ref) {
  var title = _ref.title,
      _ref$status = _ref.status,
      status = _ref$status === void 0 ? 'info' : _ref$status,
      children = _ref.children,
      _ref$collapsible = _ref.collapsible,
      collapsible = _ref$collapsible === void 0 ? false : _ref$collapsible,
      _ref$iconHidden = _ref.iconHidden,
      iconHidden = _ref$iconHidden === void 0 ? false : _ref$iconHidden;

  var _useState = (0, _react.useState)(true),
      _useState2 = _slicedToArray(_useState, 2),
      collapsed = _useState2[0],
      setCollapsed = _useState2[1];

  var className = (0, _cssUtilities.classNames)(_Banner["default"].Banner, status && _Banner["default"][(0, _cssUtilities.variationName)('status', status)]);

  var titleMarkup = title && /*#__PURE__*/_react["default"].createElement(_Heading.Heading, {
    level: 3
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: collapsible && _Banner["default"].isCollapsible
  }, title));

  var showChildren = !collapsible || collapsible && !collapsed;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: className,
    role: status === 'critical' ? 'alert' : 'status',
    "aria-atomic": "true",
    "aria-live": "polite"
  }, collapsible && /*#__PURE__*/_react["default"].createElement("div", {
    className: _Banner["default"].collapsibleButton
  }, /*#__PURE__*/_react["default"].createElement(_Button.Button, {
    plain: true,
    onPress: function onPress() {
      return setCollapsed(function (prev) {
        return !prev;
      });
    }
  }, /*#__PURE__*/_react["default"].createElement(_Icon.Icon, {
    size: "small",
    source: collapsed ? 'chevronDown' : 'chevronUp'
  }))), /*#__PURE__*/_react["default"].createElement(_Bookend.Bookend, {
    leading: true
  }, !iconHidden && /*#__PURE__*/_react["default"].createElement("div", {
    className: _Banner["default"].Icon
  }, /*#__PURE__*/_react["default"].createElement(_Icon.Icon, {
    source: status
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: _Banner["default"].Content
  }, children ? /*#__PURE__*/_react["default"].createElement(_TextContainer.TextContainer, {
    spacing: "tight"
  }, titleMarkup, showChildren && /*#__PURE__*/_react["default"].createElement(_HeadingGroup.HeadingGroup, null, /*#__PURE__*/_react["default"].createElement(_View.View, null, children))) : titleMarkup)));
}