"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withDisabledBreadcrumb = exports.withActiveBreadcrumb = exports.defaultState = exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _storybookUtilities = require("../../storybook-utilities");

var _ = require(".");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var meta = {
  component: _.Breadcrumbs,
  title: 'Breadcrumbs',
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)('buyerJourney')]
};
var _default = meta;
exports["default"] = _default;

var defaultState = function defaultState() {
  return /*#__PURE__*/_react["default"].createElement(_.Breadcrumbs, {
    breadcrumbs: [{
      id: 'information',
      to: '/information',
      content: 'Information'
    }, {
      id: 'shipping',
      to: '/shipping',
      content: 'Shipping'
    }, {
      id: 'payment',
      to: '/payment',
      content: 'Payment'
    }]
  });
};

exports.defaultState = defaultState;

var withActiveBreadcrumb = function withActiveBreadcrumb() {
  return /*#__PURE__*/_react["default"].createElement(_.Breadcrumbs, {
    active: "shipping",
    breadcrumbs: [{
      id: 'information',
      to: '/information',
      content: 'Information'
    }, {
      id: 'shipping',
      to: '/shipping',
      content: 'Shipping'
    }, {
      id: 'payment',
      to: '/payment',
      content: 'Payment'
    }]
  });
};

exports.withActiveBreadcrumb = withActiveBreadcrumb;

var withDisabledBreadcrumb = function withDisabledBreadcrumb() {
  return /*#__PURE__*/_react["default"].createElement(_.Breadcrumbs, {
    breadcrumbs: [{
      id: 'information',
      to: '/information',
      content: 'Information'
    }, {
      id: 'shipping',
      to: '/shipping',
      content: 'Shipping'
    }, {
      id: 'payment',
      to: '/payment',
      content: 'Payment',
      disabled: true
    }]
  });
};

exports.withDisabledBreadcrumb = withDisabledBreadcrumb;