"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormLayout = FormLayout;
exports.FormLayoutGroup = FormLayoutGroup;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _BlockStack = require("../BlockStack");

var _Theme = require("../Theme");

var _FormLayout = _interopRequireDefault(require("./FormLayout.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function FormLayout(_ref) {
  var children = _ref.children;

  var _useThemeConfiguratio = (0, _Theme.useThemeConfiguration)(),
      spacing = _useThemeConfiguratio.formLayout.spacing;

  var normalizedSpacing = spacing === 'base' ? undefined : spacing;
  return /*#__PURE__*/_react["default"].createElement(_BlockStack.BlockStack, {
    spacing: normalizedSpacing
  }, children);
}

function FormLayoutGroup(_ref2) {
  var children = _ref2.children;

  var _useThemeConfiguratio2 = (0, _Theme.useThemeConfiguration)(),
      spacing = _useThemeConfiguratio2.formLayout.spacing;

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _cssUtilities.classNames)(_FormLayout["default"].Group, spacing && spacing !== 'base' && _FormLayout["default"][(0, _cssUtilities.variationName)('spacing', spacing)])
  }, children);
}