"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AllSpacings = exports.Alignment = exports.defaultState = exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _TextContainer = require("../TextContainer");

var _TextBlock = require("../TextBlock");

var _InlineStack = require("./InlineStack");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var meta = {
  component: _InlineStack.InlineStack,
  title: 'InlineStack'
};
var _default = meta;
exports["default"] = _default;

function Content() {
  return /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      backgroundColor: 'lightgrey'
    }
  }, /*#__PURE__*/_react["default"].createElement(_TextBlock.TextBlock, null, "This is content"));
}

function ContentLong() {
  return /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      backgroundColor: 'lightgrey'
    }
  }, /*#__PURE__*/_react["default"].createElement(_TextContainer.TextContainer, null, /*#__PURE__*/_react["default"].createElement(_TextBlock.TextBlock, null, "This is content lorem ipsum dolor sit amet, consectetur adipiscing elit eum maxime, corrupti atque voluptatum nisi modi."), /*#__PURE__*/_react["default"].createElement(_TextBlock.TextBlock, null, "This is content lorem ipsum dolor sit amet, consectetur adipiscing elit eum maxime, corrupti.")));
}

var defaultState = function defaultState() {
  return /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, null, /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), " ", /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), " ", /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), " ", /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), " ", /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), " ", /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), " ", /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), " ", /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), " ", /*#__PURE__*/_react["default"].createElement(Content, null), " ", /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), " ", /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), " ", /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null));
};

exports.defaultState = defaultState;

var Alignment = function Alignment() {
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, {
    alignment: "leading"
  }, /*#__PURE__*/_react["default"].createElement(ContentLong, null), /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null)), /*#__PURE__*/_react["default"].createElement("br", null), /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, {
    alignment: "center"
  }, /*#__PURE__*/_react["default"].createElement(ContentLong, null), /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null)), /*#__PURE__*/_react["default"].createElement("br", null), /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, {
    alignment: "trailing"
  }, /*#__PURE__*/_react["default"].createElement(ContentLong, null), /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null)), /*#__PURE__*/_react["default"].createElement("br", null), /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, {
    alignment: "baseline"
  }, /*#__PURE__*/_react["default"].createElement(ContentLong, null), /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(_TextBlock.TextBlock, {
    size: "large"
  }, "This is a large text")));
};

exports.Alignment = Alignment;

var AllSpacings = function AllSpacings() {
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, {
    spacing: "xtight"
  }, /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null)), /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, {
    spacing: "tight"
  }, /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null)), /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, null, /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null)), /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, {
    spacing: "loose"
  }, /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null)), /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, {
    spacing: "xloose"
  }, /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null), /*#__PURE__*/_react["default"].createElement(Content, null)));
};

exports.AllSpacings = AllSpacings;