"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MoneyLine = MoneyLine;
exports.MoneyLineSeparator = MoneyLineSeparator;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _InlineStack = require("../InlineStack");

var _Text = require("../Text");

var _Theme = require("../Theme");

var _MoneyLine = _interopRequireDefault(require("./MoneyLine.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function MoneyLine(_ref) {
  var label = _ref.label,
      value = _ref.value,
      subdued = _ref.subdued,
      childPosition = _ref.childPosition,
      children = _ref.children;

  var _useThemeConfiguratio = (0, _Theme.useThemeConfiguration)(),
      _useThemeConfiguratio2 = _useThemeConfiguratio.moneyLines,
      background = _useThemeConfiguratio2.background,
      inlineAlignment = _useThemeConfiguratio2.inlineAlignment,
      labelTypographyStyle = _useThemeConfiguratio2.labelTypographyStyle,
      valueTypographyStyle = _useThemeConfiguratio2.valueTypographyStyle;

  var className = (0, _cssUtilities.classNames)(_MoneyLine["default"].MoneyLine, background && _MoneyLine["default"][(0, _cssUtilities.variationName)('background', background)], inlineAlignment && _MoneyLine["default"][(0, _cssUtilities.variationName)('inlineAlignment', inlineAlignment)]);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: className,
    role: "row"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _MoneyLine["default"].Label,
    role: "rowheader"
  }, /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, {
    spacing: "tight"
  }, /*#__PURE__*/_react["default"].createElement(_Text.Text, {
    style: labelTypographyStyle
  }, label), (!childPosition || childPosition === 'default') && children)), /*#__PURE__*/_react["default"].createElement("div", {
    className: _MoneyLine["default"].Value,
    role: "cell"
  }, /*#__PURE__*/_react["default"].createElement(_InlineStack.InlineStack, {
    spacing: "tight"
  }, /*#__PURE__*/_react["default"].createElement(_Text.Text, {
    subdued: subdued,
    emphasized: !subdued,
    size: subdued ? 'small' : undefined,
    style: valueTypographyStyle
  }, value), childPosition === 'end' && children)));
}

function MoneyLineSeparator() {
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _MoneyLine["default"].MoneyLineSeparator
  });
}