"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CustomPropertiesFallback = void 0;

var _react = _interopRequireWildcard(require("react"));

var _hooks = require("../../hooks");

var legacyStyles = _interopRequireWildcard(require("../../../../utilities/legacy"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var CustomPropertiesFallback = /*#__PURE__*/(0, _react.memo)(function CustomPropertiesFallback() {
  var theme = (0, _hooks.useTheme)();

  var _useState = (0, _react.useState)(theme.customProperties),
      _useState2 = _slicedToArray(_useState, 2),
      customProperties = _useState2[0],
      setCustomProperties = _useState2[1];

  (0, _react.useEffect)(function () {
    return theme.on('preview', function (customProperties) {
      setCustomProperties(function (existing) {
        return _objectSpread(_objectSpread({}, existing), customProperties);
      });
    });
  }, [theme]);
  var css = (0, _react.useMemo)(function () {
    return toCss(customProperties);
  }, [customProperties]);
  return /*#__PURE__*/_react["default"].createElement("style", {
    dangerouslySetInnerHTML: {
      __html: css
    }
  });
});
exports.CustomPropertiesFallback = CustomPropertiesFallback;

function toCss(customProperties) {
  var _cssFromObject;

  return cssFromObject((_cssFromObject = {}, _defineProperty(_cssFromObject, ".".concat(legacyStyles.button), {
    color: customProperties.colorPrimaryText,
    background: customProperties.colorPrimary
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.button, ":hover"), {
    background: customProperties.colorPrimaryHovered
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.button, ":active"), {
    background: customProperties.colorPrimaryPressed
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorCanvas), {
    color: customProperties.colorCanvasText,
    'border-color': customProperties.colorCanvasBorder,
    'background-color': customProperties.colorCanvas
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorCanvas, " .").concat(legacyStyles.utilityDefaultBorderColor), {
    'border-color': customProperties.colorCanvasBorder
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorCanvas, " .").concat(legacyStyles.utilityDefaultTextColorSubdued), {
    color: customProperties.colorCanvasTextSubdued
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorCanvas, " .").concat(legacyStyles.utilityDefaultTextColorEmphasized), {
    color: customProperties.colorCanvasTextEmphasized
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfacePrimary), {
    color: customProperties.colorSurfacePrimaryText,
    'border-color': customProperties.colorSurfacePrimaryBorder,
    'background-color': customProperties.colorSurfacePrimary
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfacePrimary, " .").concat(legacyStyles.utilityDefaultBorderColor), {
    'border-color': customProperties.colorSurfacePrimaryBorder
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfacePrimary, " .").concat(legacyStyles.utilityDefaultTextColorSubdued), {
    color: customProperties.colorSurfacePrimaryTextSubdued
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfacePrimary, " .").concat(legacyStyles.utilityDefaultTextColorEmphasized), {
    color: customProperties.colorSurfacePrimaryTextEmphasized
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfaceSecondary), {
    color: customProperties.colorSurfaceSecondaryText,
    'border-color': customProperties.colorSurfaceSecondaryBorder,
    'background-color': customProperties.colorSurfaceSecondary
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfaceSecondary, " .").concat(legacyStyles.utilityDefaultBorderColor), {
    'border-color': customProperties.colorSurfaceSecondaryBorder
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfaceSecondary, " .").concat(legacyStyles.utilityDefaultTextColorSubdued), {
    color: customProperties.colorSurfaceSecondaryTextSubdued
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfaceSecondary, " .").concat(legacyStyles.utilityDefaultTextColorEmphasized), {
    color: customProperties.colorSurfaceSecondaryTextEmphasized
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfaceTertiary), {
    color: customProperties.colorSurfaceTertiaryText,
    'border-color': customProperties.colorSurfaceTertiaryBorder,
    'background-color': customProperties.colorSurfaceTertiary
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfaceTertiary, " .").concat(legacyStyles.utilityDefaultBorderColor), {
    'border-color': customProperties.colorSurfaceTertiaryBorder
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfaceTertiary, " .").concat(legacyStyles.utilityDefaultTextColorSubdued), {
    color: customProperties.colorSurfaceTertiaryTextSubdued
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfaceTertiary, " .").concat(legacyStyles.utilityDefaultTextColorEmphasized), {
    color: customProperties.colorSurfaceTertiaryTextEmphasized
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfaceQuaternary), {
    color: customProperties.colorSurfaceQuaternaryText,
    'border-color': customProperties.colorSurfaceQuaternaryBorder,
    'background-color': customProperties.colorSurfaceQuaternary
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfaceQuaternary, " .").concat(legacyStyles.utilityDefaultBorderColor), {
    'border-color': customProperties.colorSurfaceQuaternaryBorder
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfaceQuaternary, " .").concat(legacyStyles.utilityDefaultTextColorSubdued), {
    color: customProperties.colorSurfaceQuaternaryTextSubdued
  }), _defineProperty(_cssFromObject, ".".concat(legacyStyles.colorSurfaceQuaternary, " .").concat(legacyStyles.utilityDefaultTextColorEmphasized), {
    color: customProperties.colorSurfaceQuaternaryTextEmphasized
  }), _cssFromObject));
}

function cssFromObject(cssObject) {
  var selectors = [];

  for (var _i2 = 0, _Object$keys = Object.keys(cssObject); _i2 < _Object$keys.length; _i2++) {
    var selector = _Object$keys[_i2];
    var propertyValues = [];

    for (var _i3 = 0, _Object$keys2 = Object.keys(cssObject[selector]); _i3 < _Object$keys2.length; _i3++) {
      var property = _Object$keys2[_i3];
      var value = cssObject[selector][property];
      if (value) propertyValues.push("".concat(property, ": ").concat(value, " !important;"));
    }

    if (propertyValues.length > 0) selectors.push("".concat(selector, " {\n  ").concat(propertyValues.join('\n  '), "\n}"));
  }

  return selectors.join('\n');
}