"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createTheme = createTheme;
exports.colorSubdued = colorSubdued;
exports.colorTextEmphasized = colorTextEmphasized;
exports.colorTextSubdued = colorTextSubdued;
exports.colorBorderEmphasized = colorBorderEmphasized;
exports.UiTheme = exports.ThemeContext = void 0;

var _react = require("react");

var _hsluv = require("../../utilities/hsluv");

var _modularScale = require("./utilities/modularScale");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _construct(Parent, args, Class) { if (_isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ThemeContext = /*#__PURE__*/(0, _react.createContext)(undefined);
exports.ThemeContext = ThemeContext;

function createTheme() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$global = _ref.global,
      global = _ref$global === void 0 ? {} : _ref$global,
      _ref$buyerJourney = _ref.buyerJourney,
      buyerJourney = _ref$buyerJourney === void 0 ? {} : _ref$buyerJourney,
      _ref$typographyScale = _ref.typographyScale,
      typographyScale = _ref$typographyScale === void 0 ? {} : _ref$typographyScale,
      _ref$typographyPrimar = _ref.typographyPrimary,
      typographyPrimary = _ref$typographyPrimar === void 0 ? {} : _ref$typographyPrimar,
      _ref$typographySecond = _ref.typographySecondary,
      typographySecondary = _ref$typographySecond === void 0 ? {} : _ref$typographySecond,
      _ref$headingLevel = _ref.headingLevel1,
      headingLevel1 = _ref$headingLevel === void 0 ? {} : _ref$headingLevel,
      _ref$headingLevel2 = _ref.headingLevel2,
      headingLevel2 = _ref$headingLevel2 === void 0 ? {} : _ref$headingLevel2,
      _ref$headingLevel3 = _ref.headingLevel3,
      headingLevel3 = _ref$headingLevel3 === void 0 ? {} : _ref$headingLevel3,
      _ref$controls = _ref.controls,
      controls = _ref$controls === void 0 ? {} : _ref$controls,
      _ref$label = _ref.label,
      label = _ref$label === void 0 ? {} : _ref$label,
      _ref$textFields = _ref.textFields,
      textFields = _ref$textFields === void 0 ? {} : _ref$textFields,
      _ref$select = _ref.select,
      select = _ref$select === void 0 ? {} : _ref$select,
      _ref$checkbox = _ref.checkbox,
      checkbox = _ref$checkbox === void 0 ? {} : _ref$checkbox,
      _ref$radio = _ref.radio,
      radio = _ref$radio === void 0 ? {} : _ref$radio,
      _ref$optionList = _ref.optionList,
      optionList = _ref$optionList === void 0 ? {} : _ref$optionList,
      _ref$reviewBlock = _ref.reviewBlock,
      reviewBlock = _ref$reviewBlock === void 0 ? {} : _ref$reviewBlock,
      _ref$actions = _ref.actions,
      actions = _ref$actions === void 0 ? {} : _ref$actions,
      _ref$lineItems = _ref.lineItems,
      lineItems = _ref$lineItems === void 0 ? {} : _ref$lineItems,
      _ref$moneyLines = _ref.moneyLines,
      moneyLines = _ref$moneyLines === void 0 ? {} : _ref$moneyLines,
      _ref$moneySummary = _ref.moneySummary,
      moneySummary = _ref$moneySummary === void 0 ? {} : _ref$moneySummary,
      _ref$primaryButton = _ref.primaryButton,
      primaryButton = _ref$primaryButton === void 0 ? {} : _ref$primaryButton,
      _ref$secondaryButton = _ref.secondaryButton,
      secondaryButton = _ref$secondaryButton === void 0 ? {} : _ref$secondaryButton,
      _ref$formLayout = _ref.formLayout,
      formLayout = _ref$formLayout === void 0 ? {} : _ref$formLayout,
      _ref$tag = _ref.tag,
      tag = _ref$tag === void 0 ? {} : _ref$tag,
      _ref$tooltip = _ref.tooltip,
      tooltip = _ref$tooltip === void 0 ? {} : _ref$tooltip,
      _ref$banner = _ref.banner,
      banner = _ref$banner === void 0 ? {} : _ref$banner,
      _ref$typographyStyle = _ref.typographyStyle1,
      typographyStyle1 = _ref$typographyStyle === void 0 ? {} : _ref$typographyStyle,
      _ref$typographyStyle2 = _ref.typographyStyle2,
      typographyStyle2 = _ref$typographyStyle2 === void 0 ? {} : _ref$typographyStyle2,
      _ref$typographyStyle3 = _ref.typographyStyle3,
      typographyStyle3 = _ref$typographyStyle3 === void 0 ? {} : _ref$typographyStyle3,
      _ref$typographyStyle4 = _ref.typographyStyle4,
      typographyStyle4 = _ref$typographyStyle4 === void 0 ? {} : _ref$typographyStyle4,
      _ref$typographyStyle5 = _ref.typographyStyle5,
      typographyStyle5 = _ref$typographyStyle5 === void 0 ? {} : _ref$typographyStyle5,
      _ref$typographyStyle6 = _ref.typographyStyle6,
      typographyStyle6 = _ref$typographyStyle6 === void 0 ? {} : _ref$typographyStyle6,
      _ref$typographyStyle7 = _ref.typographyStyle7,
      typographyStyle7 = _ref$typographyStyle7 === void 0 ? {} : _ref$typographyStyle7,
      _ref$typographyStyle8 = _ref.typographyStyle8,
      typographyStyle8 = _ref$typographyStyle8 === void 0 ? {} : _ref$typographyStyle8,
      _ref$typographyStyle9 = _ref.typographyStyle9,
      typographyStyle9 = _ref$typographyStyle9 === void 0 ? {} : _ref$typographyStyle9,
      colors = _ref.colors;

  return new UiTheme({
    global: global,
    buyerJourney: buyerJourney,
    typographyScale: typographyScale,
    typographyPrimary: typographyPrimary,
    typographySecondary: typographySecondary,
    headingLevel1: headingLevel1,
    headingLevel2: headingLevel2,
    headingLevel3: headingLevel3,
    controls: controls,
    label: label,
    textFields: textFields,
    select: select,
    checkbox: checkbox,
    radio: radio,
    optionList: optionList,
    reviewBlock: reviewBlock,
    actions: actions,
    lineItems: lineItems,
    moneyLines: moneyLines,
    moneySummary: moneySummary,
    primaryButton: primaryButton,
    secondaryButton: secondaryButton,
    formLayout: formLayout,
    tag: tag,
    tooltip: tooltip,
    banner: banner,
    typographyStyle1: typographyStyle1,
    typographyStyle2: typographyStyle2,
    typographyStyle3: typographyStyle3,
    typographyStyle4: typographyStyle4,
    typographyStyle5: typographyStyle5,
    typographyStyle6: typographyStyle6,
    typographyStyle7: typographyStyle7,
    typographyStyle8: typographyStyle8,
    typographyStyle9: typographyStyle9,
    colors: colors
  });
}
/**
 * This scaling factor represents the ratio of the height of the ratio to the base font-size of the document.
 * E.g., a font-size of 14px means that the radio element will have width & height of 18px
 */


var RADIO_SCALE = 1.2857142857142858;
var CHECKBOX_SCALE = 1.2857142857142858;

var UiTheme = /*#__PURE__*/function () {
  function UiTheme(configuration) {
    var _configuration$colors, _configuration$typogr;

    _classCallCheck(this, UiTheme);

    _defineProperty(this, "configuration", void 0);

    _defineProperty(this, "customProperties", void 0);

    _defineProperty(this, "listeners", {
      change: new Set(),
      preview: new Set()
    });

    this.configuration = _objectSpread(_objectSpread({}, configuration), {}, {
      colors: colorsFromOverrides((_configuration$colors = configuration.colors) !== null && _configuration$colors !== void 0 ? _configuration$colors : {}),
      typographyScale: (_configuration$typogr = configuration.typographyScale) !== null && _configuration$typogr !== void 0 ? _configuration$typogr : {}
    });
    this.customProperties = customPropertiesFromThemeConfiguration(this.configuration);
  }

  _createClass(UiTheme, [{
    key: "preview",
    value: function preview(colors, typographyScale) {
      var colorsCustomProperties = customPropertiesFromRoleColors(colorsFromOverrides(colors));
      var typographyScaleCustomProperties = customPropertiesFromTypographyScale(typographyScale);

      var _iterator = _createForOfIteratorHelper(this.listeners.preview),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var listener = _step.value;
          listener(_objectSpread(_objectSpread({}, colorsCustomProperties), typographyScaleCustomProperties));
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }
  }, {
    key: "set",
    value: function set(key, value) {
      this.configuration = _objectSpread(_objectSpread({}, this.configuration), {}, _defineProperty({}, key, value));

      var _iterator2 = _createForOfIteratorHelper(this.listeners.change),
          _step2;

      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var listener = _step2.value;
          listener(this.configuration);
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }

      var customProperties = customPropertiesFromThemeConfiguration(this.configuration);

      var _iterator3 = _createForOfIteratorHelper(this.listeners.preview),
          _step3;

      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var _listener = _step3.value;

          _listener(customProperties);
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }
    }
  }, {
    key: "on",
    value: function on(event, listener) {
      var _this = this;

      this.listeners[event].add(listener);
      return function () {
        _this.listeners[event]["delete"](listener);
      };
    }
  }]);

  return UiTheme;
}();

exports.UiTheme = UiTheme;

function colorSubdued(colorPair) {
  var _colorPair$background;

  return colorPair === null || colorPair === void 0 ? void 0 : (_colorPair$background = colorPair.background) === null || _colorPair$background === void 0 ? void 0 : _colorPair$background.adjust({
    l: function l(_l) {
      return _l > 50 ? _l - 1.7 : Math.max(_l - 5.2, 0);
    }
  });
}

function colorTextEmphasized(colorPair) {
  var _colorPair$foreground, _colorPair$background2;

  return (colorPair === null || colorPair === void 0 ? void 0 : colorPair.foreground) ? colorPair === null || colorPair === void 0 ? void 0 : (_colorPair$foreground = colorPair.foreground) === null || _colorPair$foreground === void 0 ? void 0 : _colorPair$foreground.adjust({
    l: function l(_l2) {
      return _l2 > 50 ? Math.min(_l2 + 15, 100) : _l2 - 10;
    }
  }) : colorPair === null || colorPair === void 0 ? void 0 : (_colorPair$background2 = colorPair.background) === null || _colorPair$background2 === void 0 ? void 0 : _colorPair$background2.adjust({
    s: function s(_s) {
      return _s > 50 ? _s : Math.min(_s + 15, 100);
    },
    l: function l(_l3) {
      return _l3 > 50 ? Math.max(_l3 - 77.5, 0) : 98.3;
    }
  });
}

function colorTextSubdued(colorPair) {
  var _colorPair$foreground2, _colorPair$background3;

  return (colorPair === null || colorPair === void 0 ? void 0 : colorPair.foreground) ? colorPair === null || colorPair === void 0 ? void 0 : (_colorPair$foreground2 = colorPair.foreground) === null || _colorPair$foreground2 === void 0 ? void 0 : _colorPair$foreground2.adjust({
    l: function l(_l4) {
      return _l4 > 50 ? Math.max(_l4 - 35, 0) : _l4 - 15;
    }
  }) : colorPair === null || colorPair === void 0 ? void 0 : (_colorPair$background3 = colorPair.background) === null || _colorPair$background3 === void 0 ? void 0 : _colorPair$background3.adjust({
    s: function s(_s2) {
      return _s2 > 50 ? Math.max(_s2 - 55, 0) : _s2;
    },
    l: function l(_l5) {
      return _l5 > 50 ? Math.max(_l5 - 49.9, 10) : Math.min(_l5 + 63.2, 90);
    }
  });
}

function colorHovered(colorPair) {
  var _colorPair$background4;

  return colorPair === null || colorPair === void 0 ? void 0 : (_colorPair$background4 = colorPair.background) === null || _colorPair$background4 === void 0 ? void 0 : _colorPair$background4.adjust({
    l: function l(_l6) {
      return _l6 - 10;
    }
  });
}

function colorPressed(colorPair) {
  var _colorPair$background5;

  return colorPair === null || colorPair === void 0 ? void 0 : (_colorPair$background5 = colorPair.background) === null || _colorPair$background5 === void 0 ? void 0 : _colorPair$background5.adjust({
    l: function l(_l7) {
      return _l7 - 10;
    }
  });
}

function colorText(colorPair) {
  var _colorPair$foreground3, _colorPair$background6;

  return (_colorPair$foreground3 = colorPair === null || colorPair === void 0 ? void 0 : colorPair.foreground) !== null && _colorPair$foreground3 !== void 0 ? _colorPair$foreground3 : colorPair === null || colorPair === void 0 ? void 0 : (_colorPair$background6 = colorPair.background) === null || _colorPair$background6 === void 0 ? void 0 : _colorPair$background6.adjust({
    l: function l(_l8) {
      return _l8 > 50 ? 4 : 96;
    }
  });
}

function colorTextHovered(colorPair) {
  var _colorPair$background7;

  return colorPair === null || colorPair === void 0 ? void 0 : (_colorPair$background7 = colorPair.background) === null || _colorPair$background7 === void 0 ? void 0 : _colorPair$background7.adjust({
    l: function l(_l9) {
      return _l9 - 10;
    }
  });
}

function colorTextPressed(colorPair) {
  var _colorPair$background8;

  return colorPair === null || colorPair === void 0 ? void 0 : (_colorPair$background8 = colorPair.background) === null || _colorPair$background8 === void 0 ? void 0 : _colorPair$background8.adjust({
    l: function l(_l10) {
      return _l10 - 10;
    }
  });
}

function colorsFromOverrides(overrideColors) {
  return Object.keys(overrideColors).reduce(function (colors, key) {
    var colorOrPair = overrideColors[key];
    if (colorOrPair == null) return colors;
    var background = colorOrPair.background,
        foreground = colorOrPair.foreground;
    return _objectSpread(_objectSpread({}, colors), {}, _defineProperty({}, key, {
      background: background ? normalizeColor(background) : undefined,
      foreground: foreground ? normalizeColor(foreground) : undefined
    }));
  }, {});
}

function colorBorder(colorPair) {
  var _colorPair$background9;

  return colorPair === null || colorPair === void 0 ? void 0 : (_colorPair$background9 = colorPair.background) === null || _colorPair$background9 === void 0 ? void 0 : _colorPair$background9.adjust({
    s: function s(_s3) {
      return _s3 > 50 ? Math.max(_s3 - 15, 0) : _s3;
    },
    l: function l(_l11) {
      return _l11 > 50 ? Math.max(_l11 - 8.8, 0) : Math.min(_l11 + 11.3, 90);
    }
  });
}

function colorBorderEmphasized(colorPair) {
  var _colorPair$background10;

  return colorPair === null || colorPair === void 0 ? void 0 : (_colorPair$background10 = colorPair.background) === null || _colorPair$background10 === void 0 ? void 0 : _colorPair$background10.adjust({
    s: function s(_s4) {
      return _s4 > 50 ? _s4 : Math.min(_s4 + 15, 100);
    },
    l: function l(_l12) {
      return _l12 > 50 ? Math.max(_l12 - 77.5, 0) : 98.3;
    }
  });
}

function normalizeColor(color) {
  if (color instanceof _hsluv.Hsl) return color;
  if (typeof color === 'string') return (0, _hsluv.parseHsl)(color);
  return _construct(_hsluv.Hsl, _toConsumableArray(color));
}

var COLOR_MAP = {
  /* COLOR CANVAS */
  colorCanvas: function colorCanvas(_ref2) {
    var canvas = _ref2.canvas;
    return canvas === null || canvas === void 0 ? void 0 : canvas.background;
  },
  colorCanvasText: function colorCanvasText(_ref3) {
    var _canvas$foreground, _canvas$background;

    var canvas = _ref3.canvas;
    return (_canvas$foreground = canvas === null || canvas === void 0 ? void 0 : canvas.foreground) !== null && _canvas$foreground !== void 0 ? _canvas$foreground : canvas === null || canvas === void 0 ? void 0 : (_canvas$background = canvas.background) === null || _canvas$background === void 0 ? void 0 : _canvas$background.adjust({
      s: function s(_s5) {
        return _s5 > 50 ? Math.max(_s5 - 55, 0) : _s5;
      },
      l: function l(_l13) {
        return _l13 > 50 ? Math.max(_l13 - 62.6, 0) : Math.min(_l13 + 82, 98.3);
      }
    });
  },
  colorCanvasTextSubdued: function colorCanvasTextSubdued(_ref4) {
    var canvas = _ref4.canvas;
    return colorTextSubdued(canvas);
  },
  colorCanvasTextEmphasized: function colorCanvasTextEmphasized(_ref5) {
    var canvas = _ref5.canvas;
    return colorTextEmphasized(canvas);
  },
  colorCanvasBorder: function colorCanvasBorder(_ref6) {
    var canvas = _ref6.canvas;
    return colorBorder(canvas);
  },
  colorCanvasBorderEmphasized: function colorCanvasBorderEmphasized(_ref7) {
    var canvas = _ref7.canvas;
    return colorBorderEmphasized(canvas);
  },

  /* COLOR SURFACE 1 */
  colorSurfacePrimary: function colorSurfacePrimary(_ref8) {
    var surfacePrimary = _ref8.surfacePrimary;
    return surfacePrimary === null || surfacePrimary === void 0 ? void 0 : surfacePrimary.background;
  },
  colorSurfacePrimaryDisabled: function colorSurfacePrimaryDisabled(_ref9) {
    var _surfacePrimary$backg;

    var surfacePrimary = _ref9.surfacePrimary;
    return surfacePrimary === null || surfacePrimary === void 0 ? void 0 : (_surfacePrimary$backg = surfacePrimary.background) === null || _surfacePrimary$backg === void 0 ? void 0 : _surfacePrimary$backg.adjust({
      l: function l(_l14) {
        return _l14 > 50 ? Math.min(_l14 - 2.5, 97.5) : Math.max(_l14 + 2.5, 2.5);
      }
    });
  },
  colorSurfacePrimarySubdued: function colorSurfacePrimarySubdued(_ref10) {
    var surfacePrimary = _ref10.surfacePrimary;
    return colorSubdued(surfacePrimary);
  },
  colorSurfacePrimaryText: function colorSurfacePrimaryText(_ref11) {
    var _surfacePrimary$foreg, _surfacePrimary$backg2;

    var surfacePrimary = _ref11.surfacePrimary;
    return (_surfacePrimary$foreg = surfacePrimary === null || surfacePrimary === void 0 ? void 0 : surfacePrimary.foreground) !== null && _surfacePrimary$foreg !== void 0 ? _surfacePrimary$foreg : surfacePrimary === null || surfacePrimary === void 0 ? void 0 : (_surfacePrimary$backg2 = surfacePrimary.background) === null || _surfacePrimary$backg2 === void 0 ? void 0 : _surfacePrimary$backg2.adjust({
      s: function s(_s6) {
        return _s6 > 50 ? Math.max(_s6 - 55, 0) : _s6;
      },
      l: function l(_l15) {
        return _l15 > 50 ? Math.max(_l15 - 62.6, 0) : Math.min(_l15 + 82, 98.3);
      }
    });
  },
  colorSurfacePrimaryTextSubdued: function colorSurfacePrimaryTextSubdued(_ref12) {
    var surfacePrimary = _ref12.surfacePrimary;
    return colorTextSubdued(surfacePrimary);
  },
  colorSurfacePrimaryTextEmphasized: function colorSurfacePrimaryTextEmphasized(_ref13) {
    var surfacePrimary = _ref13.surfacePrimary;
    return colorTextEmphasized(surfacePrimary);
  },
  colorSurfacePrimaryBorder: function colorSurfacePrimaryBorder(_ref14) {
    var surfacePrimary = _ref14.surfacePrimary;
    return colorBorder(surfacePrimary);
  },
  colorSurfacePrimaryBorderEmphasized: function colorSurfacePrimaryBorderEmphasized(_ref15) {
    var surfacePrimary = _ref15.surfacePrimary;
    return colorBorderEmphasized(surfacePrimary);
  },

  /* COLOR SURFACE 2 */
  colorSurfaceSecondary: function colorSurfaceSecondary(_ref16) {
    var surfaceSecondary = _ref16.surfaceSecondary;
    return surfaceSecondary === null || surfaceSecondary === void 0 ? void 0 : surfaceSecondary.background;
  },
  colorSurfaceSecondaryDisabled: function colorSurfaceSecondaryDisabled(_ref17) {
    var _surfaceSecondary$bac;

    var surfaceSecondary = _ref17.surfaceSecondary;
    return surfaceSecondary === null || surfaceSecondary === void 0 ? void 0 : (_surfaceSecondary$bac = surfaceSecondary.background) === null || _surfaceSecondary$bac === void 0 ? void 0 : _surfaceSecondary$bac.adjust({
      l: function l(_l16) {
        return _l16 > 50 ? Math.min(_l16 - 2.5, 97.5) : Math.max(_l16 + 2.5, 2.5);
      }
    });
  },
  colorSurfaceSecondarySubdued: function colorSurfaceSecondarySubdued(_ref18) {
    var surfaceSecondary = _ref18.surfaceSecondary;
    return colorSubdued(surfaceSecondary);
  },
  colorSurfaceSecondaryText: function colorSurfaceSecondaryText(_ref19) {
    var _surfaceSecondary$for, _surfaceSecondary$bac2;

    var surfaceSecondary = _ref19.surfaceSecondary;
    return (_surfaceSecondary$for = surfaceSecondary === null || surfaceSecondary === void 0 ? void 0 : surfaceSecondary.foreground) !== null && _surfaceSecondary$for !== void 0 ? _surfaceSecondary$for : surfaceSecondary === null || surfaceSecondary === void 0 ? void 0 : (_surfaceSecondary$bac2 = surfaceSecondary.background) === null || _surfaceSecondary$bac2 === void 0 ? void 0 : _surfaceSecondary$bac2.adjust({
      s: function s(_s7) {
        return _s7 > 50 ? Math.max(_s7 - 55, 0) : _s7;
      },
      l: function l(_l17) {
        return _l17 > 50 ? Math.max(_l17 - 62.6, 0) : Math.min(_l17 + 82, 98.3);
      }
    });
  },
  colorSurfaceSecondaryTextSubdued: function colorSurfaceSecondaryTextSubdued(_ref20) {
    var surfaceSecondary = _ref20.surfaceSecondary;
    return colorTextSubdued(surfaceSecondary);
  },
  colorSurfaceSecondaryTextEmphasized: function colorSurfaceSecondaryTextEmphasized(_ref21) {
    var surfaceSecondary = _ref21.surfaceSecondary;
    return colorTextEmphasized(surfaceSecondary);
  },
  colorSurfaceSecondaryBorder: function colorSurfaceSecondaryBorder(_ref22) {
    var surfaceSecondary = _ref22.surfaceSecondary;
    return colorBorder(surfaceSecondary);
  },
  colorSurfaceSecondaryBorderEmphasized: function colorSurfaceSecondaryBorderEmphasized(_ref23) {
    var surfaceSecondary = _ref23.surfaceSecondary;
    return colorBorderEmphasized(surfaceSecondary);
  },

  /* COLOR SURFACE 3 */
  colorSurfaceTertiary: function colorSurfaceTertiary(_ref24) {
    var surfaceTertiary = _ref24.surfaceTertiary;
    return surfaceTertiary === null || surfaceTertiary === void 0 ? void 0 : surfaceTertiary.background;
  },
  colorSurfaceTertiaryDisabled: function colorSurfaceTertiaryDisabled(_ref25) {
    var _surfaceTertiary$back;

    var surfaceTertiary = _ref25.surfaceTertiary;
    return surfaceTertiary === null || surfaceTertiary === void 0 ? void 0 : (_surfaceTertiary$back = surfaceTertiary.background) === null || _surfaceTertiary$back === void 0 ? void 0 : _surfaceTertiary$back.adjust({
      l: function l(_l18) {
        return _l18 > 50 ? Math.min(_l18 - 2.5, 97.5) : Math.max(_l18 + 2.5, 2.5);
      }
    });
  },
  colorSurfaceTertiarySubdued: function colorSurfaceTertiarySubdued(_ref26) {
    var surfaceTertiary = _ref26.surfaceTertiary;
    return colorSubdued(surfaceTertiary);
  },
  colorSurfaceTertiaryText: function colorSurfaceTertiaryText(_ref27) {
    var _surfaceTertiary$fore, _surfaceTertiary$back2;

    var surfaceTertiary = _ref27.surfaceTertiary;
    return (_surfaceTertiary$fore = surfaceTertiary === null || surfaceTertiary === void 0 ? void 0 : surfaceTertiary.foreground) !== null && _surfaceTertiary$fore !== void 0 ? _surfaceTertiary$fore : surfaceTertiary === null || surfaceTertiary === void 0 ? void 0 : (_surfaceTertiary$back2 = surfaceTertiary.background) === null || _surfaceTertiary$back2 === void 0 ? void 0 : _surfaceTertiary$back2.adjust({
      s: function s(_s8) {
        return _s8 > 50 ? Math.max(_s8 - 55, 0) : _s8;
      },
      l: function l(_l19) {
        return _l19 > 50 ? Math.max(_l19 - 62.6, 0) : Math.min(_l19 + 82, 98.3);
      }
    });
  },
  colorSurfaceTertiaryTextSubdued: function colorSurfaceTertiaryTextSubdued(_ref28) {
    var surfaceTertiary = _ref28.surfaceTertiary;
    return colorTextSubdued(surfaceTertiary);
  },
  colorSurfaceTertiaryTextEmphasized: function colorSurfaceTertiaryTextEmphasized(_ref29) {
    var surfaceTertiary = _ref29.surfaceTertiary;
    return colorTextEmphasized(surfaceTertiary);
  },
  colorSurfaceTertiaryBorder: function colorSurfaceTertiaryBorder(_ref30) {
    var surfaceTertiary = _ref30.surfaceTertiary;
    return colorBorder(surfaceTertiary);
  },
  colorSurfaceTertiaryBorderEmphasized: function colorSurfaceTertiaryBorderEmphasized(_ref31) {
    var surfaceTertiary = _ref31.surfaceTertiary;
    return colorBorderEmphasized(surfaceTertiary);
  },

  /* COLOR SURFACE 4 */
  colorSurfaceQuaternary: function colorSurfaceQuaternary(_ref32) {
    var surfaceQuaternary = _ref32.surfaceQuaternary;
    return surfaceQuaternary === null || surfaceQuaternary === void 0 ? void 0 : surfaceQuaternary.background;
  },
  colorSurfaceQuaternaryDisabled: function colorSurfaceQuaternaryDisabled(_ref33) {
    var _surfaceQuaternary$ba;

    var surfaceQuaternary = _ref33.surfaceQuaternary;
    return surfaceQuaternary === null || surfaceQuaternary === void 0 ? void 0 : (_surfaceQuaternary$ba = surfaceQuaternary.background) === null || _surfaceQuaternary$ba === void 0 ? void 0 : _surfaceQuaternary$ba.adjust({
      l: function l(_l20) {
        return _l20 > 50 ? Math.min(_l20 - 2.5, 97.5) : Math.max(_l20 + 2.5, 2.5);
      }
    });
  },
  colorSurfaceQuaternarySubdued: function colorSurfaceQuaternarySubdued(_ref34) {
    var surfaceQuaternary = _ref34.surfaceQuaternary;
    return colorSubdued(surfaceQuaternary);
  },
  colorSurfaceQuaternaryText: function colorSurfaceQuaternaryText(_ref35) {
    var _surfaceQuaternary$fo, _surfaceQuaternary$ba2;

    var surfaceQuaternary = _ref35.surfaceQuaternary;
    return (_surfaceQuaternary$fo = surfaceQuaternary === null || surfaceQuaternary === void 0 ? void 0 : surfaceQuaternary.foreground) !== null && _surfaceQuaternary$fo !== void 0 ? _surfaceQuaternary$fo : surfaceQuaternary === null || surfaceQuaternary === void 0 ? void 0 : (_surfaceQuaternary$ba2 = surfaceQuaternary.background) === null || _surfaceQuaternary$ba2 === void 0 ? void 0 : _surfaceQuaternary$ba2.adjust({
      s: function s(_s9) {
        return _s9 > 50 ? Math.max(_s9 - 55, 0) : _s9;
      },
      l: function l(_l21) {
        return _l21 > 50 ? Math.max(_l21 - 62.6, 0) : Math.min(_l21 + 82, 98.3);
      }
    });
  },
  colorSurfaceQuaternaryTextSubdued: function colorSurfaceQuaternaryTextSubdued(_ref36) {
    var surfaceQuaternary = _ref36.surfaceQuaternary;
    return colorTextSubdued(surfaceQuaternary);
  },
  colorSurfaceQuaternaryTextEmphasized: function colorSurfaceQuaternaryTextEmphasized(_ref37) {
    var surfaceQuaternary = _ref37.surfaceQuaternary;
    return colorTextEmphasized(surfaceQuaternary);
  },
  colorSurfaceQuaternaryBorder: function colorSurfaceQuaternaryBorder(_ref38) {
    var surfaceQuaternary = _ref38.surfaceQuaternary;
    return colorBorder(surfaceQuaternary);
  },
  colorSurfaceQuaternaryBorderEmphasized: function colorSurfaceQuaternaryBorderEmphasized(_ref39) {
    var surfaceQuaternary = _ref39.surfaceQuaternary;
    return colorBorderEmphasized(surfaceQuaternary);
  },

  /* COLOR PRIMARY */
  colorPrimary: function colorPrimary(_ref40) {
    var primary = _ref40.primary;
    return primary === null || primary === void 0 ? void 0 : primary.background;
  },
  colorPrimaryHovered: function colorPrimaryHovered(_ref41) {
    var primary = _ref41.primary;
    return colorHovered(primary);
  },
  colorPrimaryPressed: function colorPrimaryPressed(_ref42) {
    var primary = _ref42.primary;
    return colorPressed(primary);
  },
  colorPrimaryText: function colorPrimaryText(_ref43) {
    var primary = _ref43.primary;
    return colorText(primary);
  },
  colorPrimaryTextHovered: function colorPrimaryTextHovered(_ref44) {
    var primary = _ref44.primary;
    return colorTextHovered(primary);
  },
  colorPrimaryTextPressed: function colorPrimaryTextPressed(_ref45) {
    var primary = _ref45.primary;
    return colorTextPressed(primary);
  },

  /* COLOR SECONDARY */
  colorSecondary: function colorSecondary(_ref46) {
    var secondary = _ref46.secondary;
    return secondary === null || secondary === void 0 ? void 0 : secondary.background;
  },
  colorSecondaryHovered: function colorSecondaryHovered(_ref47) {
    var secondary = _ref47.secondary;
    return colorHovered(secondary);
  },
  colorSecondaryPressed: function colorSecondaryPressed(_ref48) {
    var secondary = _ref48.secondary;
    return colorPressed(secondary);
  },
  colorSecondaryText: function colorSecondaryText(_ref49) {
    var secondary = _ref49.secondary;
    return colorText(secondary);
  },
  colorSecondaryTextHovered: function colorSecondaryTextHovered(_ref50) {
    var secondary = _ref50.secondary;
    return colorTextHovered(secondary);
  },
  colorSecondaryTextPressed: function colorSecondaryTextPressed(_ref51) {
    var secondary = _ref51.secondary;
    return colorTextPressed(secondary);
  },

  /* COLOR TERTIARY */
  colorTertiary: function colorTertiary(_ref52) {
    var tertiary = _ref52.tertiary;
    return tertiary === null || tertiary === void 0 ? void 0 : tertiary.background;
  },
  colorTertiaryText: function colorTertiaryText(_ref53) {
    var tertiary = _ref53.tertiary;
    return colorText(tertiary);
  },
  colorTertiaryTextSubdued: function colorTertiaryTextSubdued(_ref54) {
    var _tertiary$foreground, _tertiary$background;

    var tertiary = _ref54.tertiary;
    return (tertiary === null || tertiary === void 0 ? void 0 : tertiary.foreground) ? tertiary === null || tertiary === void 0 ? void 0 : (_tertiary$foreground = tertiary.foreground) === null || _tertiary$foreground === void 0 ? void 0 : _tertiary$foreground.adjust({
      l: function l(_l22) {
        return Math.min(_l22 + 20, 100);
      }
    }) : tertiary === null || tertiary === void 0 ? void 0 : (_tertiary$background = tertiary.background) === null || _tertiary$background === void 0 ? void 0 : _tertiary$background.adjust({
      s: function s(_s10) {
        return _s10 > 50 ? Math.max(_s10 - 55, 0) : _s10;
      },
      l: function l(_l23) {
        return _l23 > 50 ? Math.max(_l23 - 49.9, 10) : Math.min(_l23 + 63.2, 90);
      }
    });
  },

  /* COLOR INTERACTIVE */
  colorInteractive: function colorInteractive(_ref55) {
    var interactive = _ref55.interactive;
    return interactive === null || interactive === void 0 ? void 0 : interactive.background;
  },
  colorInteractiveHovered: function colorInteractiveHovered(_ref56) {
    var interactive = _ref56.interactive;
    return interactive === null || interactive === void 0 ? void 0 : interactive.background;
  },
  colorInteractivePressed: function colorInteractivePressed(_ref57) {
    var interactive = _ref57.interactive;
    return interactive === null || interactive === void 0 ? void 0 : interactive.background;
  },
  colorInteractiveText: function colorInteractiveText(_ref58) {
    var interactive = _ref58.interactive;
    return interactive === null || interactive === void 0 ? void 0 : interactive.foreground;
  },
  colorInteractiveTextHovered: function colorInteractiveTextHovered(_ref59) {
    var _interactive$foregrou;

    var interactive = _ref59.interactive;
    return interactive === null || interactive === void 0 ? void 0 : (_interactive$foregrou = interactive.foreground) === null || _interactive$foregrou === void 0 ? void 0 : _interactive$foregrou.adjust({
      l: function l(_l24) {
        return _l24 + 10;
      }
    });
  },
  colorInteractiveTextPressed: function colorInteractiveTextPressed(_ref60) {
    var _interactive$foregrou2;

    var interactive = _ref60.interactive;
    return interactive === null || interactive === void 0 ? void 0 : (_interactive$foregrou2 = interactive.foreground) === null || _interactive$foregrou2 === void 0 ? void 0 : _interactive$foregrou2.adjust({
      l: function l(_l25) {
        return _l25 + 10;
      }
    });
  },

  /* COLOR CRITICAL */
  colorCritical: function colorCritical(_ref61) {
    var critical = _ref61.critical;
    return critical === null || critical === void 0 ? void 0 : critical.background;
  },
  colorCriticalText: function colorCriticalText(_ref62) {
    var critical = _ref62.critical;
    return critical === null || critical === void 0 ? void 0 : critical.foreground;
  },
  colorCriticalBorder: function colorCriticalBorder(_ref63) {
    var _critical$background;

    var critical = _ref63.critical;
    return critical === null || critical === void 0 ? void 0 : (_critical$background = critical.background) === null || _critical$background === void 0 ? void 0 : _critical$background.adjust({
      l: function l(_l26) {
        return _l26 - 17.5;
      }
    });
  },
  colorCriticalBorderEmphasized: function colorCriticalBorderEmphasized(_ref64) {
    var critical = _ref64.critical;
    return critical === null || critical === void 0 ? void 0 : critical.foreground;
  }
};
var TYPOGRAPHY_SCALE_MAP = {
  typographySizeXSmall: function typographySizeXSmall(_ref65) {
    var base = _ref65.base,
        ratio = _ref65.ratio;
    return base ? (0, _modularScale.modularScale)(-1, base, ratio) : undefined;
  },
  typographySizeSmall: function typographySizeSmall(_ref66) {
    var base = _ref66.base,
        ratio = _ref66.ratio;
    return base ? (0, _modularScale.modularScale)(-0.5, base, ratio) : undefined;
  },
  typographySizeDefault: function typographySizeDefault(_ref67) {
    var base = _ref67.base,
        ratio = _ref67.ratio;
    return base ? (0, _modularScale.modularScale)(0, base, ratio) : undefined;
  },
  typographySizeMedium: function typographySizeMedium(_ref68) {
    var base = _ref68.base,
        ratio = _ref68.ratio;
    return base ? (0, _modularScale.modularScale)(0.5, base, ratio) : undefined;
  },
  typographySizeLarge: function typographySizeLarge(_ref69) {
    var base = _ref69.base,
        ratio = _ref69.ratio;
    return base ? (0, _modularScale.modularScale)(1, base, ratio) : undefined;
  },
  typographySizeXLarge: function typographySizeXLarge(_ref70) {
    var base = _ref70.base,
        ratio = _ref70.ratio;
    return base ? (0, _modularScale.modularScale)(2, base, ratio) : undefined;
  },
  typographySizeXXLarge: function typographySizeXXLarge(_ref71) {
    var base = _ref71.base,
        ratio = _ref71.ratio;
    return base ? (0, _modularScale.modularScale)(3, base, ratio) : undefined;
  }
};
var TYPOGRAPHY_SIZE_MAP = {
  xsmall: 'var(--x-typography-size-xsmall)',
  small: 'var(--x-typography-size-small)',
  base: 'var(--x-typography-size-default)',
  medium: 'var(--x-typography-size-medium)',
  large: 'var(--x-typography-size-large)',
  xlarge: 'var(--x-typography-size-xlarge)',
  xxlarge: 'var(--x-typography-size-xxlarge)'
};
var TYPOGRAPHY_CASE_MAP = {
  none: 'none',
  title: 'capitalize',
  upper: 'uppercase',
  lower: 'lowercase'
};
var TYPOGRAPHY_FONTS_MAP = {
  primary: 'var(--x-typography-primary-fonts)',
  secondary: 'var(--x-typography-secondary-fonts)'
};
var TYPOGRAPHY_KERNING_MAP = {
  base: 'normal',
  loose: '0.125em',
  xloose: '0.16em'
};
var TYPOGRAPHY_LINE_SIZE_MAP = {
  base: '1.3',
  large: '1.5'
};
var TYPOGRAPHY_PRIMARY_WEIGHT_MAP = {
  base: 'var(--x-typography-primary-weight-base)',
  bold: 'var(--x-typography-primary-weight-bold)'
};
var TYPOGRAPHY_SECONDARY_WEIGHT_MAP = {
  base: 'var(--x-typography-secondary-weight-base)',
  bold: 'var(--x-typography-secondary-weight-bold)'
};
var SPACING_RATIO = 1.225;
var SPACING_MAP = {
  spacingTight4x: function spacingTight4x(_ref72) {
    var base = _ref72.base;
    return base ? (0, _modularScale.modularScale)(-5, base, SPACING_RATIO) : undefined;
  },
  spacingTight3x: function spacingTight3x(_ref73) {
    var base = _ref73.base;
    return base ? (0, _modularScale.modularScale)(-4, base, SPACING_RATIO) : undefined;
  },
  spacingTight2x: function spacingTight2x(_ref74) {
    var base = _ref74.base;
    return base ? (0, _modularScale.modularScale)(-3, base, SPACING_RATIO) : undefined;
  },
  spacingTight1x: function spacingTight1x(_ref75) {
    var base = _ref75.base;
    return base ? (0, _modularScale.modularScale)(-2, base, SPACING_RATIO) : undefined;
  },
  spacingTight: function spacingTight(_ref76) {
    var base = _ref76.base;
    return base ? (0, _modularScale.modularScale)(-1, base, SPACING_RATIO) : undefined;
  },
  spacingBase: function spacingBase(_ref77) {
    var base = _ref77.base;
    return base ? (0, _modularScale.modularScale)(0, base, SPACING_RATIO) : undefined;
  },
  spacingLoose: function spacingLoose(_ref78) {
    var base = _ref78.base;
    return base ? (0, _modularScale.modularScale)(1, base, SPACING_RATIO) : undefined;
  },
  spacingLoose1x: function spacingLoose1x(_ref79) {
    var base = _ref79.base;
    return base ? (0, _modularScale.modularScale)(2, base, SPACING_RATIO) : undefined;
  },
  spacingLoose2x: function spacingLoose2x(_ref80) {
    var base = _ref80.base;
    return base ? (0, _modularScale.modularScale)(3, base, SPACING_RATIO) : undefined;
  },
  spacingLoose3x: function spacingLoose3x(_ref81) {
    var base = _ref81.base;
    return base ? (0, _modularScale.modularScale)(4, base, SPACING_RATIO) : undefined;
  },
  spacingLoose4x: function spacingLoose4x(_ref82) {
    var base = _ref82.base;
    return base ? (0, _modularScale.modularScale)(5, base, SPACING_RATIO) : undefined;
  }
};
var SIMPLE_BORDER_RADIUS_MAP = {
  none: 'var(--x-border-radius-none)',
  base: 'var(--x-border-radius-base)'
};

var BORDER_RADIUS_MAP = _objectSpread(_objectSpread({}, SIMPLE_BORDER_RADIUS_MAP), {}, {
  tight: 'var(--x-border-radius-tight)',
  fullyRounded: 'var(--x-border-radius-fully-rounded)'
});

var BORDER_MAP = {
  full: 'var(--x-border-full)',
  blockEnd: 'var(--x-border-block-end)',
  none: 'var(--x-border-none)'
};
var OPTION_LIST_GAP_MAP = {
  base: 'var(--x-spacing-base)',
  tight: 'var(--x-spacing-tight4x)',
  none: '0'
};
var MONEY_LINES_GAP_MAP = {
  base: 'var(--x-spacing-tight)',
  tight: 'var(--x-spacing-tight1x)',
  none: '0'
};
var MONEY_LINES_SEPARATOR_GAP_MAP = {
  base: 'var(--x-spacing-loose1x)',
  tight: 'var(--x-spacing-base)',
  none: '0'
};
var REVIEW_BLOCK_GAP_MAP = {
  base: 'var(--x-spacing-base)',
  tight: 'var(--x-spacing-tight4x)',
  none: '0'
};
var BUYER_JOURNEY_GAP_MAP = {
  base: 'var(--x-spacing-tight1x)',
  loose: 'var(--x-spacing-loose2x)'
};
var SPACING_VAR_MAP = {
  none: '0',
  tight4x: 'var(--x-spacing-tight4x)',
  tight3x: 'var(--x-spacing-tight3x)',
  tight2x: 'var(--x-spacing-tight2x)',
  tight1x: 'var(--x-spacing-tight1x)',
  tight: 'var(--x-spacing-tight)',
  base: 'var(--x-spacing-base)',
  loose: 'var(--x-spacing-loose)',
  loose1x: 'var(--x-spacing-loose1x)',
  loose2x: 'var(--x-spacing-loose2x)',
  loose3x: 'var(--x-spacing-loose3x)',
  loose4x: 'var(--x-spacing-loose4x)'
};

function customPropertiesFromThemeConfiguration(_ref83) {
  var _typographyPrimary$fo, _typographyPrimary$we, _typographyPrimary$we2, _typographySecondary$, _typographySecondary$2, _typographySecondary$3;

  var global = _ref83.global,
      buyerJourney = _ref83.buyerJourney,
      colors = _ref83.colors,
      typographyScale = _ref83.typographyScale,
      typographyPrimary = _ref83.typographyPrimary,
      typographySecondary = _ref83.typographySecondary,
      controls = _ref83.controls,
      textFields = _ref83.textFields,
      select = _ref83.select,
      optionList = _ref83.optionList,
      checkbox = _ref83.checkbox,
      moneyLines = _ref83.moneyLines,
      moneySummary = _ref83.moneySummary,
      reviewBlock = _ref83.reviewBlock,
      primaryButton = _ref83.primaryButton,
      secondaryButton = _ref83.secondaryButton,
      tag = _ref83.tag,
      banner = _ref83.banner,
      typographyStyle1 = _ref83.typographyStyle1,
      typographyStyle2 = _ref83.typographyStyle2,
      typographyStyle3 = _ref83.typographyStyle3,
      typographyStyle4 = _ref83.typographyStyle4,
      typographyStyle5 = _ref83.typographyStyle5,
      typographyStyle6 = _ref83.typographyStyle6,
      typographyStyle7 = _ref83.typographyStyle7,
      typographyStyle8 = _ref83.typographyStyle8,
      typographyStyle9 = _ref83.typographyStyle9;
  var globalTypographyLetterCase = maybeInMap(TYPOGRAPHY_CASE_MAP)(global.typographyLetterCase);
  var globalTypographyLineSize = maybeInMap(TYPOGRAPHY_LINE_SIZE_MAP)(global.typographyLineSize);
  var globalTypographyKerning = maybeInMap(TYPOGRAPHY_KERNING_MAP)(global.typographyKerning);
  var globalBorderRadius = maybeInMap(BORDER_RADIUS_MAP)(global.borderRadius);
  var controlBorderRadius = maybeInMap(SIMPLE_BORDER_RADIUS_MAP)(controls.borderRadius);
  var textFieldBorderRadius = maybeInMap(BORDER_RADIUS_MAP)(textFields.borderRadius);
  var selectBorderRadius = maybeInMap(BORDER_RADIUS_MAP)(select.borderRadius);
  var optionListBorderRadius = maybeInMap(BORDER_RADIUS_MAP)(optionList.borderRadius);
  var checkboxBorderRadius = maybeInMap(BORDER_RADIUS_MAP)(checkbox.borderRadius);
  var reviewBlockBorderRadius = maybeInMap(BORDER_RADIUS_MAP)(reviewBlock.borderRadius);

  var _map = [textFields.border, select.border, checkbox.border].map(maybeInMap(BORDER_MAP)),
      _map2 = _slicedToArray(_map, 3),
      textFieldBorder = _map2[0],
      selectBorder = _map2[1],
      checkboxBorder = _map2[2];

  var typographyPrimaryFonts = (_typographyPrimary$fo = typographyPrimary.fonts) !== null && _typographyPrimary$fo !== void 0 ? _typographyPrimary$fo : undefined;
  var typographyPrimaryWeightBase = (_typographyPrimary$we = typographyPrimary.weightBase) !== null && _typographyPrimary$we !== void 0 ? _typographyPrimary$we : undefined;
  var typographyPrimaryWeightBold = (_typographyPrimary$we2 = typographyPrimary.weightBold) !== null && _typographyPrimary$we2 !== void 0 ? _typographyPrimary$we2 : undefined;
  var typographySecondaryFonts = (_typographySecondary$ = typographySecondary.fonts) !== null && _typographySecondary$ !== void 0 ? _typographySecondary$ : undefined;
  var typographySecondaryWeightBase = (_typographySecondary$2 = typographySecondary.weightBase) !== null && _typographySecondary$2 !== void 0 ? _typographySecondary$2 : undefined;
  var typographySecondaryWeightBold = (_typographySecondary$3 = typographySecondary.weightBold) !== null && _typographySecondary$3 !== void 0 ? _typographySecondary$3 : undefined;
  var optionListBlockGap = maybeInMap(OPTION_LIST_GAP_MAP)(optionList.gap);
  var moneyLinesBlockGap = maybeInMap(MONEY_LINES_GAP_MAP)(moneyLines.gap);
  var moneyLinesSeparatorBlockGap = maybeInMap(MONEY_LINES_SEPARATOR_GAP_MAP)(moneyLines.gap);
  var buyerJourneyInlineGap = maybeInMap(BUYER_JOURNEY_GAP_MAP)(buyerJourney.gap);
  var reviewBlockBlockGap = maybeInMap(REVIEW_BLOCK_GAP_MAP)(reviewBlock.gap);
  var reviewBlockBorder = maybeInMap(BORDER_MAP)(reviewBlock.border);

  var _map$reduce = [typographyStyle1, typographyStyle2, typographyStyle3, typographyStyle4, typographyStyle5, typographyStyle6, typographyStyle7, typographyStyle8, typographyStyle9].map(function (style) {
    return [maybeInMap(TYPOGRAPHY_SIZE_MAP)(style.size), maybeInMap(TYPOGRAPHY_CASE_MAP)(style.letterCase), maybeInMap(TYPOGRAPHY_FONTS_MAP)(style.fonts), style.weight ? typographyWeightMapping(style.fonts ? style.fonts : 'secondary', style.weight) : undefined, maybeInMap(TYPOGRAPHY_LINE_SIZE_MAP)(style.lineSize), maybeInMap(TYPOGRAPHY_KERNING_MAP)(style.kerning)];
  }).reduce(function (accumulator, array) {
    return [].concat(_toConsumableArray(accumulator), _toConsumableArray(array));
  }, []),
      _map$reduce2 = _slicedToArray(_map$reduce, 54),
      style1TypographySize = _map$reduce2[0],
      style1TypographyCase = _map$reduce2[1],
      style1TypographyFonts = _map$reduce2[2],
      style1TypographyWeight = _map$reduce2[3],
      style1TypographyLineSize = _map$reduce2[4],
      style1TypographyKerning = _map$reduce2[5],
      style2TypographySize = _map$reduce2[6],
      style2TypographyCase = _map$reduce2[7],
      style2TypographyFonts = _map$reduce2[8],
      style2TypographyWeight = _map$reduce2[9],
      style2TypographyLineSize = _map$reduce2[10],
      style2TypographyKerning = _map$reduce2[11],
      style3TypographySize = _map$reduce2[12],
      style3TypographyCase = _map$reduce2[13],
      style3TypographyFonts = _map$reduce2[14],
      style3TypographyWeight = _map$reduce2[15],
      style3TypographyLineSize = _map$reduce2[16],
      style3TypographyKerning = _map$reduce2[17],
      style4TypographySize = _map$reduce2[18],
      style4TypographyCase = _map$reduce2[19],
      style4TypographyFonts = _map$reduce2[20],
      style4TypographyWeight = _map$reduce2[21],
      style4TypographyLineSize = _map$reduce2[22],
      style4TypographyKerning = _map$reduce2[23],
      style5TypographySize = _map$reduce2[24],
      style5TypographyCase = _map$reduce2[25],
      style5TypographyFonts = _map$reduce2[26],
      style5TypographyWeight = _map$reduce2[27],
      style5TypographyLineSize = _map$reduce2[28],
      style5TypographyKerning = _map$reduce2[29],
      style6TypographySize = _map$reduce2[30],
      style6TypographyCase = _map$reduce2[31],
      style6TypographyFonts = _map$reduce2[32],
      style6TypographyWeight = _map$reduce2[33],
      style6TypographyLineSize = _map$reduce2[34],
      style6TypographyKerning = _map$reduce2[35],
      style7TypographySize = _map$reduce2[36],
      style7TypographyCase = _map$reduce2[37],
      style7TypographyFonts = _map$reduce2[38],
      style7TypographyWeight = _map$reduce2[39],
      style7TypographyLineSize = _map$reduce2[40],
      style7TypographyKerning = _map$reduce2[41],
      style8TypographySize = _map$reduce2[42],
      style8TypographyCase = _map$reduce2[43],
      style8TypographyFonts = _map$reduce2[44],
      style8TypographyWeight = _map$reduce2[45],
      style8TypographyLineSize = _map$reduce2[46],
      style8TypographyKerning = _map$reduce2[47],
      style9TypographySize = _map$reduce2[48],
      style9TypographyCase = _map$reduce2[49],
      style9TypographyFonts = _map$reduce2[50],
      style9TypographyWeight = _map$reduce2[51],
      style9TypographyLineSize = _map$reduce2[52],
      style9TypographyKerning = _map$reduce2[53];

  var primaryButtonBlockPadding = maybeInMap(SPACING_VAR_MAP)(primaryButton.blockPadding);
  var primaryButtonInlinePadding = maybeInMap(SPACING_VAR_MAP)(primaryButton.inlinePadding);
  var secondaryButtonBlockPadding = maybeInMap(SPACING_VAR_MAP)(secondaryButton.blockPadding);
  var secondaryButtonInlinePadding = maybeInMap(SPACING_VAR_MAP)(secondaryButton.inlinePadding);
  var moneyLinesBlockPadding = maybeInMap(SPACING_VAR_MAP)(moneyLines.blockPadding);
  var moneyLinesInlinePadding = maybeInMap(SPACING_VAR_MAP)(moneyLines.inlinePadding);
  var moneySummaryBlockPadding = maybeInMap(SPACING_VAR_MAP)(moneySummary.blockPadding);
  var moneySummaryInlinePadding = maybeInMap(SPACING_VAR_MAP)(moneySummary.inlinePadding);
  var optionListBlockPadding = maybeInMap(SPACING_VAR_MAP)(optionList.blockPadding);
  var optionListInlinePadding = maybeInMap(SPACING_VAR_MAP)(optionList.inlinePadding);
  var tagBorderRadius = maybeInMap(BORDER_RADIUS_MAP)(tag.borderRadius);
  /** To avoid an oval-y shape caused by sub-pixel dimensions, we need JS to floor the size of our radio buttons. */

  var radioSize = typographyScale.base ? "".concat(Math.floor(parseFloat(typographyScale.base.toString()) * RADIO_SCALE), "px") : undefined;
  /** To avoid an rectangular shape caused by sub-pixel dimensions, we need JS to floor the size of our checkboxes. */

  var checkboxSize = typographyScale.base ? "".concat(Math.floor(parseFloat(typographyScale.base.toString()) * CHECKBOX_SCALE), "px") : undefined;
  var bannerBorder = maybeInMap(BORDER_MAP)(banner.border);
  var bannerBorderRadius = maybeInMap(BORDER_RADIUS_MAP)(banner.borderRadius);

  var customProperties = _objectSpread(_objectSpread(_objectSpread(_objectSpread({}, customPropertiesFromRoleColors(colorsFromOverrides(colors))), customPropertiesFromTypographyScale(typographyScale)), customPropertiesFromSpacing(typographyScale)), {}, {
    typographyPrimaryFonts: typographyPrimaryFonts,
    typographyPrimaryWeightBase: typographyPrimaryWeightBase,
    typographyPrimaryWeightBold: typographyPrimaryWeightBold,
    typographySecondaryFonts: typographySecondaryFonts,
    typographySecondaryWeightBase: typographySecondaryWeightBase,
    typographySecondaryWeightBold: typographySecondaryWeightBold,
    globalTypographyLetterCase: globalTypographyLetterCase,
    globalTypographyLineSize: globalTypographyLineSize,
    globalTypographyKerning: globalTypographyKerning,
    globalBorderRadius: globalBorderRadius,
    controlBorderRadius: controlBorderRadius,
    checkboxBorder: checkboxBorder,
    checkboxBorderRadius: checkboxBorderRadius,
    textFieldBorder: textFieldBorder,
    textFieldBorderRadius: textFieldBorderRadius,
    selectBorderRadius: selectBorderRadius,
    selectBorder: selectBorder,
    optionListBorderRadius: optionListBorderRadius,
    optionListBlockGap: optionListBlockGap,
    reviewBlockBorderRadius: reviewBlockBorderRadius,
    reviewBlockBlockGap: reviewBlockBlockGap,
    reviewBlockBorder: reviewBlockBorder,
    moneyLinesBlockGap: moneyLinesBlockGap,
    moneyLinesSeparatorBlockGap: moneyLinesSeparatorBlockGap,
    buyerJourneyInlineGap: buyerJourneyInlineGap,
    style1TypographySize: style1TypographySize,
    style1TypographyCase: style1TypographyCase,
    style1TypographyFonts: style1TypographyFonts,
    style1TypographyWeight: style1TypographyWeight,
    style1TypographyLineSize: style1TypographyLineSize,
    style1TypographyKerning: style1TypographyKerning,
    style2TypographySize: style2TypographySize,
    style2TypographyCase: style2TypographyCase,
    style2TypographyFonts: style2TypographyFonts,
    style2TypographyWeight: style2TypographyWeight,
    style2TypographyLineSize: style2TypographyLineSize,
    style2TypographyKerning: style2TypographyKerning,
    style3TypographySize: style3TypographySize,
    style3TypographyCase: style3TypographyCase,
    style3TypographyFonts: style3TypographyFonts,
    style3TypographyWeight: style3TypographyWeight,
    style3TypographyLineSize: style3TypographyLineSize,
    style3TypographyKerning: style3TypographyKerning,
    style4TypographySize: style4TypographySize,
    style4TypographyCase: style4TypographyCase,
    style4TypographyFonts: style4TypographyFonts,
    style4TypographyWeight: style4TypographyWeight,
    style4TypographyLineSize: style4TypographyLineSize,
    style4TypographyKerning: style4TypographyKerning,
    style5TypographySize: style5TypographySize,
    style5TypographyCase: style5TypographyCase,
    style5TypographyFonts: style5TypographyFonts,
    style5TypographyWeight: style5TypographyWeight,
    style5TypographyLineSize: style5TypographyLineSize,
    style5TypographyKerning: style5TypographyKerning,
    style6TypographySize: style6TypographySize,
    style6TypographyCase: style6TypographyCase,
    style6TypographyFonts: style6TypographyFonts,
    style6TypographyWeight: style6TypographyWeight,
    style6TypographyLineSize: style6TypographyLineSize,
    style6TypographyKerning: style6TypographyKerning,
    style7TypographySize: style7TypographySize,
    style7TypographyCase: style7TypographyCase,
    style7TypographyFonts: style7TypographyFonts,
    style7TypographyWeight: style7TypographyWeight,
    style7TypographyLineSize: style7TypographyLineSize,
    style7TypographyKerning: style7TypographyKerning,
    style8TypographySize: style8TypographySize,
    style8TypographyCase: style8TypographyCase,
    style8TypographyFonts: style8TypographyFonts,
    style8TypographyWeight: style8TypographyWeight,
    style8TypographyLineSize: style8TypographyLineSize,
    style8TypographyKerning: style8TypographyKerning,
    style9TypographySize: style9TypographySize,
    style9TypographyCase: style9TypographyCase,
    style9TypographyFonts: style9TypographyFonts,
    style9TypographyWeight: style9TypographyWeight,
    style9TypographyLineSize: style9TypographyLineSize,
    style9TypographyKerning: style9TypographyKerning,
    primaryButtonBlockPadding: primaryButtonBlockPadding,
    primaryButtonInlinePadding: primaryButtonInlinePadding,
    secondaryButtonBlockPadding: secondaryButtonBlockPadding,
    secondaryButtonInlinePadding: secondaryButtonInlinePadding,
    moneyLinesBlockPadding: moneyLinesBlockPadding,
    moneyLinesInlinePadding: moneyLinesInlinePadding,
    moneySummaryBlockPadding: moneySummaryBlockPadding,
    moneySummaryInlinePadding: moneySummaryInlinePadding,
    optionListBlockPadding: optionListBlockPadding,
    optionListInlinePadding: optionListInlinePadding,
    tagBorderRadius: tagBorderRadius,
    radioSize: radioSize,
    checkboxSize: checkboxSize,
    bannerBorder: bannerBorder,
    bannerBorderRadius: bannerBorderRadius
  });

  var _iterator4 = _createForOfIteratorHelper(Object.keys(customProperties)),
      _step4;

  try {
    for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
      var key = _step4.value;

      if (customProperties[key] == null) {
        delete customProperties[key];
      }
    }
  } catch (err) {
    _iterator4.e(err);
  } finally {
    _iterator4.f();
  }

  return customProperties;
}

function customPropertiesFromRoleColors(colors) {
  var customProperties = {};

  var _iterator5 = _createForOfIteratorHelper(Object.keys(COLOR_MAP)),
      _step5;

  try {
    for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
      var _COLOR_MAP$property;

      var property = _step5.value;
      var color = (_COLOR_MAP$property = COLOR_MAP[property]) === null || _COLOR_MAP$property === void 0 ? void 0 : _COLOR_MAP$property.call(COLOR_MAP, colors);
      if (color != null) customProperties[property] = (0, _hsluv.toRgb)(color);
    }
  } catch (err) {
    _iterator5.e(err);
  } finally {
    _iterator5.f();
  }

  return customProperties;
}

function customPropertiesFromTypographyScale(scale) {
  var customProperties = {};

  var _iterator6 = _createForOfIteratorHelper(Object.keys(TYPOGRAPHY_SCALE_MAP)),
      _step6;

  try {
    for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
      var _TYPOGRAPHY_SCALE_MAP;

      var property = _step6.value;
      var fontSize = (_TYPOGRAPHY_SCALE_MAP = TYPOGRAPHY_SCALE_MAP[property]) === null || _TYPOGRAPHY_SCALE_MAP === void 0 ? void 0 : _TYPOGRAPHY_SCALE_MAP.call(TYPOGRAPHY_SCALE_MAP, scale);
      if (fontSize != null) customProperties[property] = fontSize;
    }
  } catch (err) {
    _iterator6.e(err);
  } finally {
    _iterator6.f();
  }

  return customProperties;
}

function customPropertiesFromSpacing(scale) {
  var customProperties = {};

  var _iterator7 = _createForOfIteratorHelper(Object.keys(SPACING_MAP)),
      _step7;

  try {
    for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
      var _SPACING_MAP$property;

      var property = _step7.value;
      var spacing = (_SPACING_MAP$property = SPACING_MAP[property]) === null || _SPACING_MAP$property === void 0 ? void 0 : _SPACING_MAP$property.call(SPACING_MAP, scale);
      if (spacing != null) customProperties[property] = spacing;
    }
  } catch (err) {
    _iterator7.e(err);
  } finally {
    _iterator7.f();
  }

  return customProperties;
}

function typographyWeightMapping(fontStack, weight) {
  return fontStack === 'primary' ? TYPOGRAPHY_PRIMARY_WEIGHT_MAP[weight] : TYPOGRAPHY_SECONDARY_WEIGHT_MAP[weight];
}

function maybeInMap(map) {
  return function (value) {
    return value ? map[value] : undefined;
  };
}