"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Thumbnail = Thumbnail;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _Thumbnail = _interopRequireDefault(require("./Thumbnail.css"));

var _images = require("./images");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function Thumbnail(_ref) {
  var description = _ref.description,
      _ref$border = _ref.border,
      border = _ref$border === void 0 ? 'full' : _ref$border,
      source = _ref.source,
      sources = _ref.sources,
      badge = _ref.badge,
      _ref$badgeBackground = _ref.badgeBackground,
      badgeBackground = _ref$badgeBackground === void 0 ? 'subdued' : _ref$badgeBackground;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _cssUtilities.classNames)(_Thumbnail["default"].Thumbnail, border && _Thumbnail["default"][(0, _cssUtilities.variationName)('border', border)])
  }, badge != null && /*#__PURE__*/_react["default"].createElement("span", {
    className: (0, _cssUtilities.classNames)(_Thumbnail["default"].Badge, _Thumbnail["default"][(0, _cssUtilities.variationName)('Badge-background', badgeBackground)]),
    "aria-hidden": true
  }, badge), /*#__PURE__*/_react["default"].createElement("img", {
    className: _Thumbnail["default"].Image,
    srcSet: sources === null || sources === void 0 ? void 0 : sources.join(', '),
    src: source !== null && source !== void 0 ? source : _images.placeholder,
    alt: description
  }));
}