import React from 'react';
import { withKnobs } from '@storybook/addon-knobs';
import { themeWithKnobs } from '../../storybook-utilities';
import { BlockStack } from '../BlockStack';
import { Text } from '../Text';
import { Banner } from './Banner';
var meta = {
  component: Banner,
  title: 'Banner',
  decorators: [withKnobs, themeWithKnobs('banner', 'headingLevel3')]
};
export default meta;
export var allBanners = function allBanners() {
  return /*#__PURE__*/React.createElement(BlockStack, null, /*#__PURE__*/React.createElement(Banner, {
    title: "This is an informative message"
  }), /*#__PURE__*/React.createElement(Banner, {
    status: "success",
    title: "This is a success message"
  }), /*#__PURE__*/React.createElement(Banner, {
    status: "warning",
    title: "This is a warning message"
  }), /*#__PURE__*/React.createElement(Banner, {
    status: "critical",
    title: "This is an error message"
  }));
};
export var withContent = function withContent() {
  return /*#__PURE__*/React.createElement(BlockStack, null, /*#__PURE__*/React.createElement(Banner, {
    title: "This is an informative message"
  }, /*#__PURE__*/React.createElement(Text, null, "Lorem ipsum, dolor sit amet consectetur adipisicing elit. Dolores commodi, vitae explicabo, laudantium consequatur eaque dignissimos dolorem optio minus porro nesciunt magni reprehenderit accusamus quasi sit architecto sequi nihil.")));
};
export var withoutIcon = function withoutIcon() {
  return /*#__PURE__*/React.createElement(Banner, {
    title: "Your order was updated on March 19, 2020",
    iconHidden: true
  });
};
export var collapsible = function collapsible() {
  return /*#__PURE__*/React.createElement(Banner, {
    title: "Your order was updated on March 19, 2020",
    collapsible: true
  }, /*#__PURE__*/React.createElement(Text, null, "Here are some details."));
};