function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState } from 'react';
import { withKnobs } from '@storybook/addon-knobs';
import { themeWithKnobs } from '../../storybook-utilities';
import { ButtonGroup } from '../ButtonGroup';
import { Button } from './Button';
var meta = {
  component: Button,
  title: 'Button',
  decorators: [withKnobs, themeWithKnobs('primaryButton', 'secondaryButton')]
};
export default meta;
export var allButtons = function allButtons() {
  return /*#__PURE__*/React.createElement(ButtonGroup, null, /*#__PURE__*/React.createElement(Button, null, "Default"), /*#__PURE__*/React.createElement(Button, {
    secondary: true
  }, "Secondary"), /*#__PURE__*/React.createElement(Button, {
    disabled: true
  }, "Disabled"), /*#__PURE__*/React.createElement(Button, {
    to: "/"
  }, "With URL prop"), /*#__PURE__*/React.createElement(Button, {
    subdued: true
  }, "Subdued"), /*#__PURE__*/React.createElement(Button, {
    plain: true
  }, "Plain"));
};

function ToggleLoader() {
  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      loading = _useState2[0],
      setLoading = _useState2[1];

  var defaultProps = {
    loading: loading,
    loadingLabel: 'Processing…',
    onPress: function onPress() {
      return setLoading(true);
    }
  };
  return /*#__PURE__*/React.createElement(ButtonGroup, null, /*#__PURE__*/React.createElement(Button, defaultProps, "Default"), /*#__PURE__*/React.createElement(Button, Object.assign({
    secondary: true
  }, defaultProps), "Secondary"), /*#__PURE__*/React.createElement(Button, Object.assign({
    disabled: true
  }, defaultProps), "Disabled"), /*#__PURE__*/React.createElement(Button, Object.assign({
    to: "/"
  }, defaultProps), "With URL prop"), /*#__PURE__*/React.createElement(Button, Object.assign({
    subdued: true
  }, defaultProps), "Subdued"), /*#__PURE__*/React.createElement(Button, Object.assign({
    plain: true
  }, defaultProps), "Plain"), /*#__PURE__*/React.createElement(Button, {
    plain: true,
    onPress: function onPress() {
      return setLoading(false);
    }
  }, "Stop loading"));
}

export var loading = function loading() {
  return /*#__PURE__*/React.createElement(ToggleLoader, null);
};