import React from 'react';
import { Text } from '../Text';
import { themeWithKnobs } from '../../storybook-utilities';
import { BlockStack } from '../BlockStack';
import { CalloutBanner } from './CalloutBanner';
var meta = {
  component: CalloutBanner,
  title: 'CalloutBanner',
  decorators: [themeWithKnobs('headingLevel3')]
};
export default meta;
export var title = function title() {
  return /*#__PURE__*/React.createElement(CalloutBanner, {
    title: "Special offer today only"
  }, /*#__PURE__*/React.createElement(Text, null, "Add the Dinghy Skeleton Cruiser to your order and save 15%"));
};
export var withoutTitle = function withoutTitle() {
  return /*#__PURE__*/React.createElement(CalloutBanner, null, /*#__PURE__*/React.createElement(Text, null, "Add the Dinghy Skeleton Cruiser to your order and save 15%. This offer ends in ", /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "04:48")));
};
export var border = function border() {
  return /*#__PURE__*/React.createElement(CalloutBanner, {
    border: "none"
  }, /*#__PURE__*/React.createElement(Text, null, "Add the Dinghy Skeleton Cruiser to your order and save 15%. This offer ends in ", /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "04:48")));
};
export var background = function background() {
  return /*#__PURE__*/React.createElement(CalloutBanner, {
    background: "transparent"
  }, /*#__PURE__*/React.createElement(Text, null, "Add the Dinghy Skeleton Cruiser to your order and save 15%. This offer ends in ", /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "04:48")));
};
export var alignment = function alignment() {
  return /*#__PURE__*/React.createElement(BlockStack, null, /*#__PURE__*/React.createElement(CalloutBanner, {
    alignment: "leading"
  }, /*#__PURE__*/React.createElement(Text, null, "Add the Dinghy Skeleton Cruiser to your order and save 15%. This offer ends in ", /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "04:48"))), /*#__PURE__*/React.createElement(CalloutBanner, null, /*#__PURE__*/React.createElement(Text, null, "Add the Dinghy Skeleton Cruiser to your order and save 15%. This offer ends in ", /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "04:48"))), /*#__PURE__*/React.createElement(CalloutBanner, {
    alignment: "trailing"
  }, /*#__PURE__*/React.createElement(Text, null, "Add the Dinghy Skeleton Cruiser to your order and save 15%. This offer ends in ", /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "04:48"))));
};
export var spacing = function spacing() {
  return /*#__PURE__*/React.createElement(CalloutBanner, {
    title: "Special offer today only",
    spacing: "none"
  }, /*#__PURE__*/React.createElement(Text, null, "Add the Dinghy Skeleton Cruiser to your order and save 15%. This offer ends in ", /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "04:48")));
};