import React from 'react';
import { withKnobs } from '@storybook/addon-knobs';
import { themeWithKnobs } from '../../storybook-utilities';
import { Text } from '../Text';
import { BlockStack } from '../BlockStack';
import { Checkbox } from './Checkbox';
var meta = {
  component: Checkbox,
  title: 'Checkbox',
  decorators: [withKnobs, themeWithKnobs('checkbox')]
};
export default meta;
var defaultProps = {
  children: 'Save this information for next time'
};
export var defaultState = function defaultState() {
  return /*#__PURE__*/React.createElement(BlockStack, null, /*#__PURE__*/React.createElement(Checkbox, {
    id: "checkbox1",
    name: "checkboxchoices"
  }, "Save this information for next time"), /*#__PURE__*/React.createElement("div", {
    style: {
      width: '200px'
    }
  }, /*#__PURE__*/React.createElement(Checkbox, {
    id: "checkbox2",
    name: "checkboxchoices"
  }, "Multi-line label Lorem ipsum dolor sit amet consectetur adipisicing elit. Facere, dolores aut harum accusantium nihil excepturi nemo iusto dolore impedit officia est consectetur sint neque voluptatibus? Amet ut excepturi culpa? Mollitia?")), /*#__PURE__*/React.createElement(Checkbox, {
    id: "checkbox3",
    name: "checkboxchoices"
  }, /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "Lorem ipsum dolor sit amet"), /*#__PURE__*/React.createElement(Text, null, "consectetur adipisicing elit")));
};
export var withAccessibilityLabel = function withAccessibilityLabel() {
  return /*#__PURE__*/React.createElement(Checkbox, Object.assign({}, defaultProps, {
    accessibilityLabel: "This is a description for screen readers"
  }));
};
export var withError = function withError() {
  return /*#__PURE__*/React.createElement(Checkbox, Object.assign({}, defaultProps, {
    error: "This is an error"
  }));
};
export var disabledAndChecked = function disabledAndChecked() {
  return /*#__PURE__*/React.createElement(BlockStack, null, /*#__PURE__*/React.createElement(Checkbox, Object.assign({}, defaultProps, {
    disabled: true
  })), /*#__PURE__*/React.createElement(Checkbox, Object.assign({}, defaultProps, {
    checked: true,
    disabled: true
  })));
};