import React from 'react';
import { withKnobs } from '@storybook/addon-knobs';
import { themeWithKnobs } from '../../storybook-utilities';
import { Link } from './Link';
var meta = {
  component: Link,
  title: 'Link',
  decorators: [withKnobs, themeWithKnobs('primaryButton')]
};
export default meta;
var defaultProps = {
  to: 'https://shopify.com'
};
export var internalLink = function internalLink() {
  return /*#__PURE__*/React.createElement(Link, Object.assign({}, defaultProps, {
    external: false
  }), "Internal link");
};
export var externalLink = function externalLink() {
  return /*#__PURE__*/React.createElement(Link, Object.assign({}, defaultProps, {
    external: true
  }), "External link");
};
export var linkWithoutUrl = function linkWithoutUrl() {
  return /*#__PURE__*/React.createElement(Link, {
    underline: true,
    to: undefined
  }, "Link without Url");
};
export var underline = function underline() {
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Link, Object.assign({}, defaultProps, {
    underline: true
  }), "Just a link"), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(Link, {
    underline: true
  }, "Link without Url (rendered as a Button)"));
};