import React from 'react';
import { useLinkComponent } from '../../../AppContext';
export function UnstyledLink(_ref) {
  var children = _ref.children,
      className = _ref.className,
      to = _ref.to,
      external = _ref.external,
      id = _ref.id,
      onPress = _ref.onPress;
  var LinkComponent = useLinkComponent();

  if (LinkComponent) {
    return /*#__PURE__*/React.createElement(LinkComponent, {
      to: to,
      onClick: onPress,
      external: external,
      id: id,
      className: className
    }, children);
  }

  var target = external ? '_blank' : undefined;
  var rel = external ? 'noopener noreferrer' : undefined;
  return /*#__PURE__*/React.createElement("a", {
    href: to,
    onClick: onPress,
    target: target,
    rel: rel,
    id: id,
    className: className
  }, children);
}