function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState } from 'react';
import { withKnobs } from '@storybook/addon-knobs';
import faker from 'faker';
import { themeWithKnobs } from '../../storybook-utilities';
import { Text } from '../Text';
import { Button } from '../Button';
import { Modal } from './Modal';
var meta = {
  component: Modal,
  title: 'Modal',
  decorators: [withKnobs, themeWithKnobs('headingLevel1')]
};
export default meta;
export var withContent = function withContent() {
  return /*#__PURE__*/React.createElement(Modal, {
    open: true
  }, /*#__PURE__*/React.createElement(Text, null, faker.lorem.paragraphs(1)));
};
export var withVeryLongContent = function withVeryLongContent() {
  return /*#__PURE__*/React.createElement(Modal, {
    open: true
  }, /*#__PURE__*/React.createElement(Text, null, faker.lorem.paragraphs(100)));
};
export var withExplicitHeight = function withExplicitHeight() {
  return /*#__PURE__*/React.createElement(Modal, {
    open: true,
    height: 300
  }, /*#__PURE__*/React.createElement(Text, null, faker.lorem.paragraphs(100)));
};
export var withTitle = function withTitle() {
  return /*#__PURE__*/React.createElement(Modal, {
    title: faker.random.words(3),
    open: true
  }, /*#__PURE__*/React.createElement(Text, null, faker.lorem.paragraphs(1)));
};
export var withLongTitle = function withLongTitle() {
  return /*#__PURE__*/React.createElement(Modal, {
    title: faker.random.words(8),
    open: true
  }, /*#__PURE__*/React.createElement(Text, null, faker.lorem.paragraphs(1)));
};
export var iframe = function iframe() {
  return /*#__PURE__*/React.createElement(Modal, {
    src: "https://www.example.com/",
    open: true
  });
};
export var iframeWithTitle = function iframeWithTitle() {
  return /*#__PURE__*/React.createElement(Modal, {
    src: "http://www.example.com/",
    title: faker.random.words(3),
    open: true
  });
};
export var iframeWithExplicitHeight = function iframeWithExplicitHeight() {
  return /*#__PURE__*/React.createElement(Modal, {
    src: "http://www.example.com/",
    open: true,
    height: 300
  });
};

var Closed = function Closed() {
  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      open = _useState2[0],
      setOpen = _useState2[1];

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Button, {
    onPress: function onPress() {
      return setOpen(true);
    }
  }, "Show modal"), /*#__PURE__*/React.createElement(Modal, {
    title: faker.random.words(3),
    open: open,
    onClose: function onClose() {
      return setOpen(false);
    }
  }, /*#__PURE__*/React.createElement(Text, null, faker.lorem.paragraphs(1))));
};

export var closed = function closed() {
  return /*#__PURE__*/React.createElement(Closed, null);
};