import React from 'react';
import { classNames, variationName } from '@shopify/css-utilities';
import { InlineStack } from '../InlineStack';
import { Text } from '../Text';
import { useThemeConfiguration } from '../Theme';
import styles from './MoneyLine.css';
export function MoneyLine(_ref) {
  var label = _ref.label,
      value = _ref.value,
      subdued = _ref.subdued,
      childPosition = _ref.childPosition,
      children = _ref.children;

  var _useThemeConfiguratio = useThemeConfiguration(),
      _useThemeConfiguratio2 = _useThemeConfiguratio.moneyLines,
      background = _useThemeConfiguratio2.background,
      inlineAlignment = _useThemeConfiguratio2.inlineAlignment,
      labelTypographyStyle = _useThemeConfiguratio2.labelTypographyStyle,
      valueTypographyStyle = _useThemeConfiguratio2.valueTypographyStyle;

  var className = classNames(styles.MoneyLine, background && styles[variationName('background', background)], inlineAlignment && styles[variationName('inlineAlignment', inlineAlignment)]);
  return /*#__PURE__*/React.createElement("div", {
    className: className,
    role: "row"
  }, /*#__PURE__*/React.createElement("div", {
    className: styles.Label,
    role: "rowheader"
  }, /*#__PURE__*/React.createElement(InlineStack, {
    spacing: "tight"
  }, /*#__PURE__*/React.createElement(Text, {
    style: labelTypographyStyle
  }, label), (!childPosition || childPosition === 'default') && children)), /*#__PURE__*/React.createElement("div", {
    className: styles.Value,
    role: "cell"
  }, /*#__PURE__*/React.createElement(InlineStack, {
    spacing: "tight"
  }, /*#__PURE__*/React.createElement(Text, {
    subdued: subdued,
    emphasized: !subdued,
    size: subdued ? 'small' : undefined,
    style: valueTypographyStyle
  }, value), childPosition === 'end' && children)));
}
export function MoneyLineSeparator() {
  return /*#__PURE__*/React.createElement("div", {
    className: styles.MoneyLineSeparator
  });
}