import React from 'react';
import { MaybeVisuallyHidden } from '../VisuallyHidden';
import { Heading } from '../Heading';
import { createIdCreator } from '../../utilities/id';
import styles from './MoneyLines.css';
var createId = createIdCreator('MoneyLine-Heading');
export function MoneyLines(_ref) {
  var children = _ref.children,
      title = _ref.title,
      _ref$titleHidden = _ref.titleHidden,
      titleHidden = _ref$titleHidden === void 0 ? true : _ref$titleHidden;
  var headingId = createId();
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(MaybeVisuallyHidden, {
    condition: titleHidden
  }, /*#__PURE__*/React.createElement(Heading, {
    id: headingId
  }, title)), /*#__PURE__*/React.createElement("div", {
    className: styles.MoneyLines,
    role: "table",
    "aria-labelledby": headingId
  }, children));
}