import React from 'react';
import { classNames, variationName } from '@shopify/css-utilities';
import { useOptionList } from '../../hooks';
import styles from '../../OptionList.css';
import { useThemeConfiguration } from '../../../Theme';
export function OptionDetails(_ref) {
  var controlledBy = _ref.controlledBy,
      children = _ref.children;

  var _useOptionList = useOptionList(),
      selectedItems = _useOptionList.selectedItems;

  var _useThemeConfiguratio = useThemeConfiguration(),
      detailsBackground = _useThemeConfiguratio.optionList.detailsBackground;

  if (!children || !selectedItems.includes(controlledBy)) {
    return null;
  }

  return /*#__PURE__*/React.createElement("div", {
    className: classNames(styles.Details, detailsBackground && styles[variationName('Details-background', detailsBackground)])
  }, children);
}