import React from 'react';
import { withKnobs } from '@storybook/addon-knobs';
import { themeWithKnobs } from '../../storybook-utilities';
import { Text } from '../Text';
import { BlockStack } from '../BlockStack';
import { Radio } from './Radio';
var meta = {
  component: Radio,
  title: 'Radio',
  decorators: [withKnobs, themeWithKnobs('radio')]
};
export default meta;
var defaultProps = {
  name: 'Radio',
  children: 'Save this information for next time'
};
export var defaultState = function defaultState() {
  return /*#__PURE__*/React.createElement("div", {
    style: {
      width: '250px'
    }
  }, /*#__PURE__*/React.createElement(BlockStack, null, /*#__PURE__*/React.createElement(Radio, {
    id: "radio1",
    name: "radiochoices"
  }, "Save this information for next time"), /*#__PURE__*/React.createElement(Radio, {
    id: "radio2",
    name: "radiochoices"
  }, "Lorem ipsum dolor sit amet consectetur adipisicing elit. Facere, dolores aut harum accusantium nihil excepturi nemo iusto dolore impedit officia est consectetur sint neque voluptatibus? Amet ut excepturi culpa? Mollitia?"), /*#__PURE__*/React.createElement(Radio, {
    id: "radio3",
    name: "radiochoices"
  }, /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "Lorem ipsum dolor sit amet"), /*#__PURE__*/React.createElement(Text, null, "consectetur adipisicing elit"))));
};
export var withAccessibilityLabel = function withAccessibilityLabel() {
  return /*#__PURE__*/React.createElement(Radio, Object.assign({}, defaultProps, {
    accessibilityLabel: "This is a description for screen readers"
  }));
};
export var disabledAndChecked = function disabledAndChecked() {
  return /*#__PURE__*/React.createElement(BlockStack, null, /*#__PURE__*/React.createElement(Radio, Object.assign({}, defaultProps, {
    disabled: true
  })), /*#__PURE__*/React.createElement(Radio, Object.assign({}, defaultProps, {
    checked: true,
    disabled: true
  })));
};