import React from 'react';
import { Text } from '../Text';
import { Thumbnail } from '../Thumbnail';
import { ResourceItem, ResourceItemContent } from '../ResourceItem';
import { ResourceList, ResourceListHeader, ResourceListHeaderContent } from './ResourceList';
var meta = {
  component: ResourceList,
  title: 'ResourceList',
  decorators: [function (story) {
    return /*#__PURE__*/React.createElement("div", {
      style: {
        margin: '1em'
      }
    }, story());
  }]
};
export default meta;

function Item() {
  return /*#__PURE__*/React.createElement(ResourceItem, null, /*#__PURE__*/React.createElement(ResourceItemContent, null, /*#__PURE__*/React.createElement(Thumbnail, {
    description: "some media source",
    badge: 1
  })), /*#__PURE__*/React.createElement(ResourceItemContent, {
    primary: true
  }, /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "T-shirt"), /*#__PURE__*/React.createElement(Text, {
    subdued: true
  }, "L/Blue")), /*#__PURE__*/React.createElement(ResourceItemContent, null, /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "$12.00")));
}

export var multipleItems = function multipleItems() {
  return /*#__PURE__*/React.createElement(ResourceList, null, /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null));
};
export var oneItem = function oneItem() {
  return /*#__PURE__*/React.createElement(ResourceList, null, /*#__PURE__*/React.createElement(Item, null));
};
export var borderBlockEnd = function borderBlockEnd() {
  return /*#__PURE__*/React.createElement(ResourceList, {
    border: "blockEnd"
  }, /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null));
};
export var borderFull = function borderFull() {
  return /*#__PURE__*/React.createElement(ResourceList, {
    border: "full"
  }, /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null));
};
export var borderAroundItems = function borderAroundItems() {
  return /*#__PURE__*/React.createElement(ResourceList, {
    border: "aroundItems"
  }, /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null));
};
export var withHeader = function withHeader() {
  return /*#__PURE__*/React.createElement(ResourceList, null, /*#__PURE__*/React.createElement(ResourceListHeader, null, /*#__PURE__*/React.createElement(ResourceListHeaderContent, null, /*#__PURE__*/React.createElement(Text, null, "Image")), /*#__PURE__*/React.createElement(ResourceListHeaderContent, {
    primary: true
  }, /*#__PURE__*/React.createElement(Text, null, "Description")), /*#__PURE__*/React.createElement(ResourceListHeaderContent, null, /*#__PURE__*/React.createElement(Text, null, "Price"))), /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null));
};
export var withHiddenHeaderContent = function withHiddenHeaderContent() {
  return /*#__PURE__*/React.createElement(ResourceList, {
    titleHidden: true,
    title: "title"
  }, /*#__PURE__*/React.createElement(ResourceListHeader, null, /*#__PURE__*/React.createElement(ResourceListHeaderContent, {
    primary: true
  }, /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "test")), /*#__PURE__*/React.createElement(ResourceListHeaderContent, null, /*#__PURE__*/React.createElement(Text, {
    emphasized: true
  }, "test"))), /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null), /*#__PURE__*/React.createElement(Item, null));
};