/* eslint id-length: off */
import React, { useMemo } from 'react';
import { ThemeContext } from './context';
import { Canvas, CustomProperties, CustomPropertiesFallback } from './components';
export function Theme(_ref) {
  var children = _ref.children,
      theme = _ref.theme;
  var supportsCustomProperties = useSupportsCustomProperties();
  return /*#__PURE__*/React.createElement(ThemeContext.Provider, {
    value: theme
  }, supportsCustomProperties ? /*#__PURE__*/React.createElement(CustomProperties, null, /*#__PURE__*/React.createElement(Canvas, null, children)) : /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(CustomPropertiesFallback, null), /*#__PURE__*/React.createElement(Canvas, null, children)));
} // TODO: if we ever do server rendering, this will need to be based on UA
// string on the server to avoid server/ client mismatches.

function useSupportsCustomProperties() {
  return useMemo(function () {
    return typeof CSS !== 'undefined' && CSS.supports('color', 'var(--test)');
  }, []);
}