import React from 'react';
import { classNames, variationName } from '@shopify/css-utilities';
import styles from './Thumbnail.css';
import { placeholder } from './images';
export function Thumbnail(_ref) {
  var description = _ref.description,
      _ref$border = _ref.border,
      border = _ref$border === void 0 ? 'full' : _ref$border,
      source = _ref.source,
      sources = _ref.sources,
      badge = _ref.badge,
      _ref$badgeBackground = _ref.badgeBackground,
      badgeBackground = _ref$badgeBackground === void 0 ? 'subdued' : _ref$badgeBackground;
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(styles.Thumbnail, border && styles[variationName('border', border)])
  }, badge != null && /*#__PURE__*/React.createElement("span", {
    className: classNames(styles.Badge, styles[variationName('Badge-background', badgeBackground)]),
    "aria-hidden": true
  }, badge), /*#__PURE__*/React.createElement("img", {
    className: styles.Image,
    srcSet: sources === null || sources === void 0 ? void 0 : sources.join(', '),
    src: source !== null && source !== void 0 ? source : placeholder,
    alt: description
  }));
}