"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.disabledAndChecked = exports.withError = exports.withAccessibilityLabel = exports.defaultState = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _storybookUtilities = require("../../storybook-utilities");

var _Text = require("../Text");

var _BlockStack = require("../BlockStack");

var _Checkbox = require("./Checkbox");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const meta = {
  component: _Checkbox.Checkbox,
  title: 'Checkbox',
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)('checkbox')]
};
var _default = meta;
exports.default = _default;
const defaultProps = {
  children: 'Save this information for next time'
};

const defaultState = () => /*#__PURE__*/_react.default.createElement(_BlockStack.BlockStack, null, /*#__PURE__*/_react.default.createElement(_Checkbox.Checkbox, {
  id: "checkbox1",
  name: "checkboxchoices"
}, "Save this information for next time"), /*#__PURE__*/_react.default.createElement("div", {
  style: {
    width: '200px'
  }
}, /*#__PURE__*/_react.default.createElement(_Checkbox.Checkbox, {
  id: "checkbox2",
  name: "checkboxchoices"
}, "Multi-line label Lorem ipsum dolor sit amet consectetur adipisicing elit. Facere, dolores aut harum accusantium nihil excepturi nemo iusto dolore impedit officia est consectetur sint neque voluptatibus? Amet ut excepturi culpa? Mollitia?")), /*#__PURE__*/_react.default.createElement(_Checkbox.Checkbox, {
  id: "checkbox3",
  name: "checkboxchoices"
}, /*#__PURE__*/_react.default.createElement(_Text.Text, {
  emphasized: true
}, "Lorem ipsum dolor sit amet"), /*#__PURE__*/_react.default.createElement(_Text.Text, null, "consectetur adipisicing elit")));

exports.defaultState = defaultState;

const withAccessibilityLabel = () => /*#__PURE__*/_react.default.createElement(_Checkbox.Checkbox, Object.assign({}, defaultProps, {
  accessibilityLabel: "This is a description for screen readers"
}));

exports.withAccessibilityLabel = withAccessibilityLabel;

const withError = () => /*#__PURE__*/_react.default.createElement(_Checkbox.Checkbox, Object.assign({}, defaultProps, {
  error: "This is an error"
}));

exports.withError = withError;

const disabledAndChecked = () => /*#__PURE__*/_react.default.createElement(_BlockStack.BlockStack, null, /*#__PURE__*/_react.default.createElement(_Checkbox.Checkbox, Object.assign({}, defaultProps, {
  disabled: true
})), /*#__PURE__*/_react.default.createElement(_Checkbox.Checkbox, Object.assign({}, defaultProps, {
  checked: true,
  disabled: true
})));

exports.disabledAndChecked = disabledAndChecked;