"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Form = Form;

var _react = _interopRequireDefault(require("react"));

var _AppContext = require("../AppContext");

var _VisuallyHidden = require("../VisuallyHidden");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Form({
  onSubmit,
  children,
  disabled = false,
  implicitSubmit = true
}) {
  const t = (0, _AppContext.useTranslate)();
  const implicitSubmitContent = implicitSubmit === false ? null : /*#__PURE__*/_react.default.createElement(_VisuallyHidden.VisuallyHidden, null, /*#__PURE__*/_react.default.createElement("button", {
    type: "submit",
    disabled: disabled,
    tabIndex: -1,
    "aria-hidden": true
  }, typeof implicitSubmit === 'string' ? implicitSubmit : t('submit')));
  return /*#__PURE__*/_react.default.createElement("form", {
    action: "",
    method: "POST",
    noValidate: true,
    onSubmit: event => {
      if (disabled) return;
      event.preventDefault();
      onSubmit();
    }
  }, children, implicitSubmitContent);
}