"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormLayout = FormLayout;
exports.FormLayoutGroup = FormLayoutGroup;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _BlockStack = require("../BlockStack");

var _Theme = require("../Theme");

var _FormLayout = _interopRequireDefault(require("./FormLayout.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function FormLayout({
  children
}) {
  const {
    formLayout: {
      spacing
    }
  } = (0, _Theme.useThemeConfiguration)();
  const normalizedSpacing = spacing === 'base' ? undefined : spacing;
  return /*#__PURE__*/_react.default.createElement(_BlockStack.BlockStack, {
    spacing: normalizedSpacing
  }, children);
}

function FormLayoutGroup({
  children
}) {
  const {
    formLayout: {
      spacing
    }
  } = (0, _Theme.useThemeConfiguration)();
  return /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _cssUtilities.classNames)(_FormLayout.default.Group, spacing && spacing !== 'base' && _FormLayout.default[(0, _cssUtilities.variationName)('spacing', spacing)])
  }, children);
}