"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultState = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _storybookUtilities = require("../../storybook-utilities");

var _TextField = require("../TextField");

var _Select = require("../Select");

var _FormLayout = require("./FormLayout");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const meta = {
  title: 'FormLayout',
  component: _FormLayout.FormLayout,
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)('formLayout', 'textFields', 'select')]
};
var _default = meta;
exports.default = _default;

const defaultState = () => {
  const selectCountryProps = {
    id: 'select',
    name: 'country',
    label: 'Country',
    options: [{
      value: 'CA',
      label: 'Canada'
    }, {
      value: 'US',
      label: 'United States'
    }, {
      value: 'UK',
      label: 'United Kingdom'
    }]
  };
  const selectProvinceProps = {
    id: 'select',
    name: 'province',
    label: 'Province',
    options: [{
      value: 'QC',
      label: 'Quebec'
    }, {
      value: 'ON',
      label: 'Ontario'
    }, {
      value: 'PEI',
      label: 'Prince Edward Island'
    }]
  };
  return /*#__PURE__*/_react.default.createElement(_FormLayout.FormLayout, null, /*#__PURE__*/_react.default.createElement(_FormLayout.FormLayoutGroup, null, /*#__PURE__*/_react.default.createElement(_Select.Select, selectCountryProps), /*#__PURE__*/_react.default.createElement(_Select.Select, selectProvinceProps)), /*#__PURE__*/_react.default.createElement(_TextField.TextField, {
    label: "Address",
    name: "address1",
    id: "address1"
  }), /*#__PURE__*/_react.default.createElement(_TextField.TextField, {
    label: "Apartment, suite, etc.",
    name: "address2",
    id: "address2"
  }));
};

exports.defaultState = defaultState;