"use strict";

var _react = _interopRequireDefault(require("react"));

var _testUtilities = require("../../test-utilities");

var _TextField = require("../TextField");

var _Select = require("../Select");

var _FormLayout = require("./FormLayout");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<FormLayout />', () => {
  it('renders its children', () => {
    const selectCountryProps = {
      id: 'select',
      name: 'country',
      label: 'Country',
      options: [{
        value: 'CA',
        label: 'Canada'
      }, {
        value: 'US',
        label: 'United States'
      }, {
        value: 'UK',
        label: 'United Kingdom'
      }]
    };
    const selectProvinceProps = {
      id: 'select',
      name: 'province',
      label: 'Province',
      options: [{
        value: 'QC',
        label: 'Quebec'
      }, {
        value: 'ON',
        label: 'Ontario'
      }, {
        value: 'PEI',
        label: 'Prince Edward Island'
      }]
    };
    const formLayout = (0, _testUtilities.mountWithContext)( /*#__PURE__*/_react.default.createElement(_FormLayout.FormLayout, null, /*#__PURE__*/_react.default.createElement(_FormLayout.FormLayoutGroup, null, /*#__PURE__*/_react.default.createElement(_Select.Select, selectCountryProps), /*#__PURE__*/_react.default.createElement(_Select.Select, selectProvinceProps)), /*#__PURE__*/_react.default.createElement(_TextField.TextField, {
      name: "address1",
      id: "address1",
      label: "Address"
    }), /*#__PURE__*/_react.default.createElement(_TextField.TextField, {
      name: "address2",
      id: "address2",
      label: "Apartment, suite, etc."
    })));
    expect(formLayout).toContainReactComponentTimes(_FormLayout.FormLayoutGroup, 1);
    expect(formLayout).toContainReactComponentTimes(_TextField.TextField, 2);
  });
});