"use strict";

var _react = _interopRequireDefault(require("react"));

var _dom = require("@quilted/react-testing/dom");

var _FormattedText = require("./FormattedText");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<FormattedText />', () => {
  describe('content', () => {
    it('renders its content', () => {
      const content = 'Snowdevil';
      const formatted = (0, _dom.mount)( /*#__PURE__*/_react.default.createElement(_FormattedText.FormattedText, null, content));
      expect(formatted).toContainReactText(content);
    });
    it('replaces new line characters by <br>s', () => {
      const content = '490 Rue De La Gauchetiere O,\nMontreal,\nQC\nH2Z 0B3';
      const formatted = (0, _dom.mount)( /*#__PURE__*/_react.default.createElement(_FormattedText.FormattedText, null, content));
      expect(formatted).toContainReactHtml('490 Rue De La Gauchetiere O,<br>Montreal,<br>QC<br>H2Z 0B3');
    });
  });
});