"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Link = Link;

var _react = _interopRequireDefault(require("react"));

var _cssUtilities = require("@shopify/css-utilities");

var _Button = require("../Button");

var _components = require("./components");

var _Link = _interopRequireDefault(require("./Link.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Link is used to navigate the buyer to another page or section within the same page.
 */
function Link({
  to,
  children,
  onPress,
  underline,
  ...rest
}) {
  if (!to) {
    return /*#__PURE__*/_react.default.createElement(_Button.Button, Object.assign({
      onPress: onPress,
      plain: true,
      underline: true
    }, rest), children);
  }

  return /*#__PURE__*/_react.default.createElement(_components.UnstyledLink, Object.assign({
    className: (0, _cssUtilities.classNames)(_Link.default.Link, underline && _Link.default.underline),
    to: to,
    onPress: onPress
  }, rest), children);
}