"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.closed = exports.iframeWithExplicitHeight = exports.iframeWithTitle = exports.iframe = exports.withLongTitle = exports.withTitle = exports.withExplicitHeight = exports.withVeryLongContent = exports.withContent = exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _addonKnobs = require("@storybook/addon-knobs");

var _faker = _interopRequireDefault(require("faker"));

var _storybookUtilities = require("../../storybook-utilities");

var _Text = require("../Text");

var _Button = require("../Button");

var _Modal = require("./Modal");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const meta = {
  component: _Modal.Modal,
  title: 'Modal',
  decorators: [_addonKnobs.withKnobs, (0, _storybookUtilities.themeWithKnobs)('headingLevel1')]
};
var _default = meta;
exports.default = _default;

const withContent = () => /*#__PURE__*/_react.default.createElement(_Modal.Modal, {
  open: true
}, /*#__PURE__*/_react.default.createElement(_Text.Text, null, _faker.default.lorem.paragraphs(1)));

exports.withContent = withContent;

const withVeryLongContent = () => /*#__PURE__*/_react.default.createElement(_Modal.Modal, {
  open: true
}, /*#__PURE__*/_react.default.createElement(_Text.Text, null, _faker.default.lorem.paragraphs(100)));

exports.withVeryLongContent = withVeryLongContent;

const withExplicitHeight = () => /*#__PURE__*/_react.default.createElement(_Modal.Modal, {
  open: true,
  height: 300
}, /*#__PURE__*/_react.default.createElement(_Text.Text, null, _faker.default.lorem.paragraphs(100)));

exports.withExplicitHeight = withExplicitHeight;

const withTitle = () => /*#__PURE__*/_react.default.createElement(_Modal.Modal, {
  title: _faker.default.random.words(3),
  open: true
}, /*#__PURE__*/_react.default.createElement(_Text.Text, null, _faker.default.lorem.paragraphs(1)));

exports.withTitle = withTitle;

const withLongTitle = () => /*#__PURE__*/_react.default.createElement(_Modal.Modal, {
  title: _faker.default.random.words(8),
  open: true
}, /*#__PURE__*/_react.default.createElement(_Text.Text, null, _faker.default.lorem.paragraphs(1)));

exports.withLongTitle = withLongTitle;

const iframe = () => /*#__PURE__*/_react.default.createElement(_Modal.Modal, {
  src: "https://www.example.com/",
  open: true
});

exports.iframe = iframe;

const iframeWithTitle = () => /*#__PURE__*/_react.default.createElement(_Modal.Modal, {
  src: "http://www.example.com/",
  title: _faker.default.random.words(3),
  open: true
});

exports.iframeWithTitle = iframeWithTitle;

const iframeWithExplicitHeight = () => /*#__PURE__*/_react.default.createElement(_Modal.Modal, {
  src: "http://www.example.com/",
  open: true,
  height: 300
});

exports.iframeWithExplicitHeight = iframeWithExplicitHeight;

const Closed = () => {
  const [open, setOpen] = (0, _react.useState)(false);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Button.Button, {
    onPress: () => setOpen(true)
  }, "Show modal"), /*#__PURE__*/_react.default.createElement(_Modal.Modal, {
    title: _faker.default.random.words(3),
    open: open,
    onClose: () => setOpen(false)
  }, /*#__PURE__*/_react.default.createElement(_Text.Text, null, _faker.default.lorem.paragraphs(1))));
};

const closed = () => /*#__PURE__*/_react.default.createElement(Closed, null);

exports.closed = closed;