"use strict";

var _react = _interopRequireDefault(require("react"));

var _faker = _interopRequireDefault(require("faker"));

var _testUtilities = require("../../test-utilities");

var _MoneySummary = require("./MoneySummary");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const defaultProps = {
  label: _faker.default.random.word(),
  value: _faker.default.finance.amount(),
  prefix: _faker.default.finance.currencyCode()
};
describe('<MoneySummary />', () => {
  it('renders a label', () => {
    const label = _faker.default.random.word();

    const moneySummary = (0, _testUtilities.mountWithContext)( /*#__PURE__*/_react.default.createElement(_MoneySummary.MoneySummary, Object.assign({}, defaultProps, {
      label: label
    })));
    expect(moneySummary).toContainReactText(label);
  });
  it('renders a prefix', () => {
    const prefix = _faker.default.random.word();

    const moneySummary = (0, _testUtilities.mountWithContext)( /*#__PURE__*/_react.default.createElement(_MoneySummary.MoneySummary, Object.assign({}, defaultProps, {
      prefix: prefix
    })));
    expect(moneySummary).toContainReactText(prefix);
  });
  it('renders a value', () => {
    const value = _faker.default.random.word();

    const moneySummary = (0, _testUtilities.mountWithContext)( /*#__PURE__*/_react.default.createElement(_MoneySummary.MoneySummary, Object.assign({}, defaultProps, {
      value: value
    })));
    expect(moneySummary).toContainReactText(value);
  });
});