"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.preventOverflow = exports.minimumInlineSize = exports.sameInlineSize = exports.placement = exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _InlineStack = require("../InlineStack");

var _Popper = require("./Popper");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const meta = {
  component: _Popper.Popper,
  title: 'Popper',
  decorators: [story => /*#__PURE__*/_react.default.createElement("div", {
    style: {
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center',
      height: '100vh'
    }
  }, story())]
};
var _default = meta;
exports.default = _default;

const Content = ({
  children
}) => {
  return /*#__PURE__*/_react.default.createElement("div", {
    style: {
      border: '1px solid red',
      padding: 10
    }
  }, children);
};

const WithPlacement = () => {
  const [referenceElement, setReferenceElement] = (0, _react.useState)(null);
  const [placement, setPlacement] = (0, _react.useState)('blockStart');

  const handleClick = placement => event => {
    setReferenceElement(event.currentTarget);
    setPlacement(placement);
  };

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, referenceElement && placement && /*#__PURE__*/_react.default.createElement(_Popper.Popper, {
    activator: referenceElement,
    placement: placement
  }, /*#__PURE__*/_react.default.createElement(Content, null, "Popper")), /*#__PURE__*/_react.default.createElement(_InlineStack.InlineStack, null, /*#__PURE__*/_react.default.createElement("button", {
    onClick: handleClick('blockStart')
  }, "blockStart"), /*#__PURE__*/_react.default.createElement("button", {
    onClick: handleClick('blockEnd')
  }, "blockEnd")));
};

const WithSameInlineSize = () => {
  const [referenceElement, setReferenceElement] = (0, _react.useState)(null);

  const handleClick = event => {
    setReferenceElement(event.currentTarget);
  };

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, referenceElement && placement && /*#__PURE__*/_react.default.createElement(_Popper.Popper, {
    activator: referenceElement,
    placement: "blockStart",
    sameInlineSize: true
  }, /*#__PURE__*/_react.default.createElement(Content, null, "Popper")), /*#__PURE__*/_react.default.createElement("button", {
    onClick: handleClick
  }, "Popper with the same inline size"));
};

const WithMinimumInlineSize = () => {
  const [referenceElement, setReferenceElement] = (0, _react.useState)(null);

  const handleClick = event => {
    setReferenceElement(event.currentTarget);
  };

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, referenceElement && placement && /*#__PURE__*/_react.default.createElement(_Popper.Popper, {
    activator: referenceElement,
    placement: "blockStart",
    minInlineSize: 480
  }, /*#__PURE__*/_react.default.createElement(Content, null, "Popper")), /*#__PURE__*/_react.default.createElement("button", {
    onClick: handleClick
  }, "Popper with a minimum inline size (480px)"));
};

const WithOverflowPrevention = () => {
  const [referenceElement, setReferenceElement] = (0, _react.useState)(null);

  const handleClick = event => {
    setReferenceElement(event.currentTarget);
  };

  return /*#__PURE__*/_react.default.createElement("div", {
    style: {
      display: 'flex',
      flex: '1',
      paddingRight: 50,
      justifyContent: 'flex-end'
    }
  }, referenceElement && placement && /*#__PURE__*/_react.default.createElement(_Popper.Popper, {
    activator: referenceElement,
    placement: "blockStart",
    preventOverflow: true
  }, /*#__PURE__*/_react.default.createElement(Content, null, "Very loooooooooooooooooooooooong Popper")), /*#__PURE__*/_react.default.createElement("button", {
    onClick: handleClick
  }, "Prevent overflow"));
};

const placement = () => /*#__PURE__*/_react.default.createElement(WithPlacement, null);

exports.placement = placement;

const sameInlineSize = () => /*#__PURE__*/_react.default.createElement(WithSameInlineSize, null);

exports.sameInlineSize = sameInlineSize;

const minimumInlineSize = () => /*#__PURE__*/_react.default.createElement(WithMinimumInlineSize, null);

exports.minimumInlineSize = minimumInlineSize;

const preventOverflow = () => /*#__PURE__*/_react.default.createElement(WithOverflowPrevention, null);

exports.preventOverflow = preventOverflow;