"use strict";

var _react = _interopRequireWildcard(require("react"));

var _dom = require("@quilted/react-testing/dom");

var _transition = require("./transition");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

jest.useFakeTimers();
describe('useTransition', () => {
  it('returns entering transition steps from exited to entered when transitionIn is true', () => {
    const spy = jest.fn();

    function EnteringTransition() {
      const [transitionIn, setTransitionIn] = (0, _react.useState)(false);
      const transition = (0, _transition.useTransition)(transitionIn);
      (0, _react.useEffect)(() => {
        setTransitionIn(true);
      }, []);
      (0, _react.useEffect)(() => {
        spy(transition);
      });
      return null;
    }

    const enteringTransition = (0, _dom.mount)( /*#__PURE__*/_react.default.createElement(EnteringTransition, null));
    enteringTransition.act(() => {
      jest.runAllTimers();
    });
    expect(spy.mock.calls).toMatchObject([['exited'], ['enter'], ['entering'], ['entered']]);
  });
  it('returns exiting transition steps from entered to exited when transitionIn is false', () => {
    const spy = jest.fn();

    function ExitingTransition() {
      const [transitionIn, setTransitionIn] = (0, _react.useState)(true);
      const transition = (0, _transition.useTransition)(transitionIn);
      (0, _react.useEffect)(() => {
        setTransitionIn(false);
      }, []);
      (0, _react.useEffect)(() => {
        spy(transition);
      });
      return null;
    }

    const exitingTransition = (0, _dom.mount)( /*#__PURE__*/_react.default.createElement(ExitingTransition, null));
    exitingTransition.act(() => {
      jest.runAllTimers();
    });
    expect(spy.mock.calls).toMatchObject([['entered'], ['exit'], ['exiting'], ['exited']]);
  });
});