"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Banner = void 0;
const react_1 = __importStar(require("react"));
const css_utilities_1 = require("@shopify/css-utilities");
const Heading_1 = require("../Heading");
const HeadingGroup_1 = require("../HeadingGroup");
const Bookend_1 = require("../Bookend");
const Icon_1 = require("../Icon");
const View_1 = require("../View");
const TextContainer_1 = require("../TextContainer");
const Button_1 = require("../Button");
const Banner_css_1 = __importDefault(require("./Banner.css"));
function Banner({ title, status = 'info', children, collapsible = false, iconHidden = false, }) {
    const [collapsed, setCollapsed] = react_1.useState(true);
    const className = css_utilities_1.classNames(Banner_css_1.default.Banner, status && Banner_css_1.default[css_utilities_1.variationName('status', status)]);
    const titleMarkup = title && (<Heading_1.Heading level={3}>
      <span className={collapsible && Banner_css_1.default.isCollapsible}>{title}</span>
    </Heading_1.Heading>);
    const showChildren = !collapsible || (collapsible && !collapsed);
    return (<div className={className} role={status === 'critical' ? 'alert' : 'status'} aria-atomic="true" aria-live="polite">
      {collapsible && (<div className={Banner_css_1.default.collapsibleButton}>
          <Button_1.Button plain onPress={() => setCollapsed((prev) => !prev)}>
            <Icon_1.Icon size="small" source={collapsed ? 'chevronDown' : 'chevronUp'}/>
          </Button_1.Button>
        </div>)}
      <Bookend_1.Bookend leading>
        {!iconHidden && (<div className={Banner_css_1.default.Icon}>
            <Icon_1.Icon source={status}/>
          </div>)}

        <div className={Banner_css_1.default.Content}>
          {children ? (<TextContainer_1.TextContainer spacing="tight">
              {titleMarkup}
              {showChildren && (<HeadingGroup_1.HeadingGroup>
                  <View_1.View>{children}</View_1.View>
                </HeadingGroup_1.HeadingGroup>)}
            </TextContainer_1.TextContainer>) : (titleMarkup)}
        </div>
      </Bookend_1.Bookend>
    </div>);
}
exports.Banner = Banner;
