"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResourceItemSeparator = exports.ResourceItem = exports.ResourceItemContent = void 0;
const react_1 = __importDefault(require("react"));
const css_utilities_1 = require("@shopify/css-utilities");
const legacy_1 = require("../../utilities/legacy");
const VisuallyHidden_1 = require("../VisuallyHidden");
const ResourceItem_css_1 = __importDefault(require("./ResourceItem.css"));
function ResourceItemContent({ children, primary, hidden, }) {
    const className = css_utilities_1.classNames(ResourceItem_css_1.default.ResourceItemContent, primary && ResourceItem_css_1.default['ResourceItemContent-isPrimary']);
    return (<div role="cell" className={className}>
      {hidden ? <VisuallyHidden_1.VisuallyHidden>{children}</VisuallyHidden_1.VisuallyHidden> : children}
    </div>);
}
exports.ResourceItemContent = ResourceItemContent;
function ResourceItem({ children, background, inlinePadding, blockPadding, }) {
    const className = css_utilities_1.classNames(ResourceItem_css_1.default.ResourceItem, legacy_1.utilityDefaultBorderColor, background && ResourceItem_css_1.default[css_utilities_1.variationName('background', background)], inlinePadding && ResourceItem_css_1.default[css_utilities_1.variationName('inlinePadding', inlinePadding)], blockPadding && ResourceItem_css_1.default[css_utilities_1.variationName('blockPadding', blockPadding)]);
    return (<div role="row" className={className}>
      {children}
    </div>);
}
exports.ResourceItem = ResourceItem;
function ResourceItemSeparator({ borderStyle, borderColor, }) {
    const className = css_utilities_1.classNames(ResourceItem_css_1.default.ResourceItemSeparator, borderStyle &&
        ResourceItem_css_1.default[css_utilities_1.variationName('ResourceItemSeparator-borderStyle', borderStyle)], borderColor &&
        ResourceItem_css_1.default[css_utilities_1.variationName('ResourceItemSeparator-borderColor', borderColor)]);
    return <div className={className}/>;
}
exports.ResourceItemSeparator = ResourceItemSeparator;
