"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.withHiddenHeaderContent = exports.withHeader = exports.borderAroundItems = exports.borderFull = exports.borderBlockEnd = exports.oneItem = exports.multipleItems = void 0;
const react_1 = __importDefault(require("react"));
const Text_1 = require("../Text");
const Thumbnail_1 = require("../Thumbnail");
const ResourceItem_1 = require("../ResourceItem");
const ResourceList_1 = require("./ResourceList");
const meta = {
    component: ResourceList_1.ResourceList,
    title: 'ResourceList',
    decorators: [
        (story) => <div style={{ margin: '1em' }}>{story()}</div>,
    ],
};
exports.default = meta;
function Item() {
    return (<ResourceItem_1.ResourceItem>
      <ResourceItem_1.ResourceItemContent>
        <Thumbnail_1.Thumbnail description="some media source" badge={1}/>
      </ResourceItem_1.ResourceItemContent>
      <ResourceItem_1.ResourceItemContent primary>
        <Text_1.Text emphasized>T-shirt</Text_1.Text>
        <Text_1.Text subdued>L/Blue</Text_1.Text>
      </ResourceItem_1.ResourceItemContent>
      <ResourceItem_1.ResourceItemContent>
        <Text_1.Text emphasized>$12.00</Text_1.Text>
      </ResourceItem_1.ResourceItemContent>
    </ResourceItem_1.ResourceItem>);
}
exports.multipleItems = () => (<ResourceList_1.ResourceList>
    <Item />
    <Item />
    <Item />
  </ResourceList_1.ResourceList>);
exports.oneItem = () => (<ResourceList_1.ResourceList>
    <Item />
  </ResourceList_1.ResourceList>);
exports.borderBlockEnd = () => (<ResourceList_1.ResourceList border="blockEnd">
    <Item />
    <Item />
    <Item />
  </ResourceList_1.ResourceList>);
exports.borderFull = () => (<ResourceList_1.ResourceList border="full">
    <Item />
    <Item />
    <Item />
  </ResourceList_1.ResourceList>);
exports.borderAroundItems = () => (<ResourceList_1.ResourceList border="aroundItems">
    <Item />
    <Item />
    <Item />
  </ResourceList_1.ResourceList>);
exports.withHeader = () => (<ResourceList_1.ResourceList>
    <ResourceList_1.ResourceListHeader>
      <ResourceList_1.ResourceListHeaderContent>
        <Text_1.Text>Image</Text_1.Text>
      </ResourceList_1.ResourceListHeaderContent>
      <ResourceList_1.ResourceListHeaderContent primary>
        <Text_1.Text>Description</Text_1.Text>
      </ResourceList_1.ResourceListHeaderContent>
      <ResourceList_1.ResourceListHeaderContent>
        <Text_1.Text>Price</Text_1.Text>
      </ResourceList_1.ResourceListHeaderContent>
    </ResourceList_1.ResourceListHeader>
    <Item />
    <Item />
    <Item />
  </ResourceList_1.ResourceList>);
exports.withHiddenHeaderContent = () => (<ResourceList_1.ResourceList titleHidden title="title">
    <ResourceList_1.ResourceListHeader>
      <ResourceList_1.ResourceListHeaderContent primary>
        <Text_1.Text emphasized>test</Text_1.Text>
      </ResourceList_1.ResourceListHeaderContent>
      <ResourceList_1.ResourceListHeaderContent>
        <Text_1.Text emphasized>test</Text_1.Text>
      </ResourceList_1.ResourceListHeaderContent>
    </ResourceList_1.ResourceListHeader>
    <Item />
    <Item />
    <Item />
  </ResourceList_1.ResourceList>);
