"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const dom_1 = require("@quilted/react-testing/dom");
const Separator_1 = require("./Separator");
describe('<Separator />', () => {
    it('renders horizontal by default', () => {
        const separator = dom_1.mount(<Separator_1.Separator />);
        expect(separator).toContainReactComponent('div', {
            style: {
                borderBottomWidth: '1px',
            },
        });
    });
    it('renders vertical', () => {
        const separator = dom_1.mount(<Separator_1.Separator direction="vertical"/>);
        expect(separator).toContainReactComponent('div', {
            style: {
                borderRightWidth: '1px',
            },
        });
    });
    it('renders width', () => {
        const separator = dom_1.mount(<Separator_1.Separator width="thick"/>);
        expect(separator).toContainReactComponent('div', {
            style: {
                borderBottomWidth: '5px',
            },
        });
    });
});
