import { ReactNode } from 'react';
export interface Props {
    children?: ReactNode;
}
export declare function Step({ children }: Props): JSX.Element;
export interface StepContentProps {
    grouped?: boolean;
    children?: ReactNode;
}
export declare function StepContent({ grouped, children }: StepContentProps): JSX.Element;
export interface StepSectionProps {
    title?: string;
    primary?: boolean;
    children?: ReactNode;
    description?: string;
}
export declare function StepSection({ title, primary, children, description, }: StepSectionProps): JSX.Element;
export interface StepSectionHeaderProps {
    title: string;
    primary?: boolean;
    description?: string;
}
export declare const STEP_SECTION_PRIMARY_HEADER_ID = "primary-header";
export declare function StepSectionHeader({ title, primary, description: descriptionProp, }: StepSectionHeaderProps): JSX.Element;
export interface StepSectionShowcaseProps {
    children?: ReactNode;
}
export declare function StepSectionShowcase({ children }: StepSectionShowcaseProps): JSX.Element;
export interface StepActionsProps {
    children?: ReactNode;
}
export declare function StepActions({ children }: StepActionsProps): JSX.Element;
export interface StepPrimaryActionProps {
    children?: ReactNode;
}
export declare function StepPrimaryAction({ children }: StepPrimaryActionProps): JSX.Element;
export interface StepSecondaryActionProps {
    children?: ReactNode;
}
export declare function StepSecondaryAction({ children }: StepSecondaryActionProps): JSX.Element;
