"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tag = void 0;
const react_1 = __importDefault(require("react"));
const Icon_1 = require("../Icon");
const Truncate_1 = require("../Truncate");
const Tag_css_1 = __importDefault(require("./Tag.css"));
/**
 * Tag is used to display a removable tag.
 */
function Tag({ children, onPress }) {
    return (<div className={Tag_css_1.default.Tag}>
      <span className={Tag_css_1.default.Label}>
        <Truncate_1.Truncate>{children}</Truncate_1.Truncate>
      </span>
      <button type="button" className={Tag_css_1.default.Button} onClick={onPress}>
        <Icon_1.Icon source="close" size="default"/>
      </button>
    </div>);
}
exports.Tag = Tag;
