/// <reference types="react" />
export interface Props {
    description: string;
    source?: string;
    /**
     * A list of source sizes for responsive images, used in [srcset](https://developer.mozilla.org/en-US/docs/Web/API/HTMLImageElement/srcset).
     * e.g., ["https://example.org/foo_100x100.jpg", "https://example.org/foo_200x200.jpg 2x"]
     */
    sources?: string[];
    border?: 'none' | 'full';
    badge?: string | number;
    badgeBackground?: 'primary' | 'subdued';
}
export declare function Thumbnail({ description, border, source, sources, badge, badgeBackground, }: Props): JSX.Element;
