"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Thumbnail = void 0;
const react_1 = __importDefault(require("react"));
const css_utilities_1 = require("@shopify/css-utilities");
const Thumbnail_css_1 = __importDefault(require("./Thumbnail.css"));
const images_1 = require("./images");
function Thumbnail({ description, border = 'full', source, sources, badge, badgeBackground = 'subdued', }) {
    return (<div className={css_utilities_1.classNames(Thumbnail_css_1.default.Thumbnail, border && Thumbnail_css_1.default[css_utilities_1.variationName('border', border)])}>
      {badge != null && (<span className={css_utilities_1.classNames(Thumbnail_css_1.default.Badge, Thumbnail_css_1.default[css_utilities_1.variationName('Badge-background', badgeBackground)])} aria-hidden>
          {badge}
        </span>)}
      <img className={Thumbnail_css_1.default.Image} srcSet={sources === null || sources === void 0 ? void 0 : sources.join(', ')} src={source !== null && source !== void 0 ? source : images_1.placeholder} alt={description}/>
    </div>);
}
exports.Thumbnail = Thumbnail;
