import { PropsWithChildren } from 'react';
import { ViewProps } from '@shopify/argo-checkout';
/**
 * A View is a generic container component. Its contents will always be their
 * “natural” size, so this component can be useful in layout components (like `Layout`, `Tiles`,
 * `BlockStack`, `InlineStack`) that would otherwise stretch their children to fit.
 */
export declare function View({ children, inlinePadding, blockPadding, }: PropsWithChildren<ViewProps>): JSX.Element;
